module ProducerConsumer =
   use ASME2SSME_LIB; 
   type thProducer_TIME_EVENT = bundle ( event pProdStart_Frozen_time_event;
                                         event pProdStop_Frozen_time_event;
                                         event pProdStartTimer_Output_time_event;
                                         event pProdStopTimer_Output_time_event;
                                         event pMsgSend_Output_time_event; );
   type thProdTimer_TIME_EVENT = bundle ( event pProdStart_Frozen_time_event;
                                          event pProdStop_Frozen_time_event;
                                          event pTimeOut_Output_time_event; );
   type thConsumer_TIME_EVENT = bundle ( event pConsStop_Frozen_time_event;
                                         event pConsStart_Frozen_time_event;
                                         event pMsgRecv_Frozen_time_event;
                                         event pConsStartTimer_Output_time_event;
                                         event pConsStopTimer_Output_time_event; );
   type thConsTimer_TIME_EVENT = bundle ( event pConsStart_Frozen_time_event;
                                          event pConsStop_Frozen_time_event;
                                          event pTimeOut_Output_time_event; );
   constant integer QueueSize = 3; % added Loic %
   process ProducerConsumer_others_System =
        ( ? event Processor1_top;
        )
      (| ProducerConsumer_others_System_behavior{}
       | ProducerConsumer_others_System_property{}
       | (pStart, pStop) := sysEnv{}()
       | sysOperatorDisplay{}(pProdTimeOut, pConsTimeOut)
       | (pProdTimeOut, pConsTimeOut) := Processor1_Processor{prProdCons_others_Process}(Processor1_top, pStart, pStop)
       |)
      where 
        boolean pStart;
        boolean pStop;
        boolean pProdTimeOut;
        boolean pConsTimeOut;
      type process TT_prProdCons_others_Process = ( ? event top;
                                             boolean pStart;
                                             boolean pStop;
                                             CTL1 thProducer_ctl1;
                                             thProducer_TIME_EVENT thProducer_time1;
                                             CTL1 thProdTimer_ctl1;
                                             thProdTimer_TIME_EVENT thProdTimer_time1;
                                             CTL1 thConsumer_ctl1;
                                             thConsumer_TIME_EVENT thConsumer_time1;
                                             CTL1 thConsTimer_ctl1;
                                             thConsTimer_TIME_EVENT thConsTimer_time1;
                                             ! boolean pProdTimeOut;
                                             boolean pConsTimeOut;
                                             CTL2 thProducer_ctl2;
                                             boolean thProducer_Alarm;
                                             CTL2 thProdTimer_ctl2;
                                             boolean thProdTimer_Alarm;
                                             CTL2 thConsumer_ctl2;
                                             boolean thConsumer_Alarm;
                                             CTL2 thConsTimer_ctl2;
                                             boolean thConsTimer_Alarm;
                                             );
      boolean L_3;
      boolean L_2;
      boolean L_1;
      boolean L_0;
      process ProducerConsumer_others_System_behavior =
           ( )
         (| (| |) |)
      %ProducerConsumer_others_System_behavior%; 
      process ProducerConsumer_others_System_property =
           ( )
         (| (| |) |)
      %ProducerConsumer_others_System_property%; 

    process sysEnv =
           ( ! boolean pStart, pStop;       )
      pragmas
        Comment " Modfied LBesnard : for simulation "
        end pragmas
    
	(| bpStart ^= bpStop ^= Processor1_top
	 | bpStart := getStart()
	 | bpStop := getStop()
	 | pStart := when bpStart | pStop := when bpStop
         | printEventPort("pStart" when pStart)
         | printEventPort("pStop" when pStop)
	|)
	where
	process getStart=(? !boolean b;) external;
	process getStop=(? !boolean b;) external;
	boolean  bpStart, bpStop;
	end;
	
      process sysOperatorDisplay =
           ( ? boolean pProdTimeOut;
               boolean pConsTimeOut;
           )
      pragmas
        Comment " Modfied LBesnard : for simulation "
        end pragmas
	(| printEventPort("pProdTimeOut" when pProdTimeOut)
	 | printEventPort("pConsTimeOut" when pConsTimeOut)	
	 |)
      ;
      process prProdCons_others_Process =
           TT_prProdCons_others_Process
         (| prProdCons_others_Process_behavior{}
          | prProdCons_others_Process_property{}
          | (L_7, L_8, L_9, L_10, thProducer_ctl2, thProducer_Alarm) := thProducer_others_Thread{}(L_4, L_5, thProducer_ctl1, thProducer_time1, top)
          | (L_15, thProdTimer_ctl2, thProdTimer_Alarm) := thProdTimer_others_Thread{}(L_12, L_13, thProdTimer_ctl1, thProdTimer_time1, top)
          | (L_21, L_22, L_23, thConsumer_ctl2, thConsumer_Alarm) := thConsumer_others_Thread{}(L_17, L_18, L_19, thConsumer_ctl1, thConsumer_time1, top)
          | (L_28, thConsTimer_ctl2, thConsTimer_Alarm) := thConsTimer_others_Thread{}(L_25, L_26, thConsTimer_ctl1, thConsTimer_time1, top)
          | (Queue_r, Queue_cnt) := fifo_reset{integer, QueueSize, 0}(Queue_w, Queue_reset)
          | dequeueItem(Queue_r) %  Modif Loic %
          | Queue_cnt ^= top
          | Queue_r ^= L_10.TRead  ^+ L_23.TRead 
          | Queue_w ^= L_10.TWrite ^+ L_23.TWrite
          | Queue_reset ::= L_10.TReset 
          | Queue_reset ::= L_23.TReset
          | Queue_reset ^=  L_10.TReset  ^+ L_23.TReset
          | L_4 := pStart
          | L_18 := pStart
          | L_5 := pStop
          | L_17 := pStop
          | pProdTimeOut := L_15
          | pConsTimeOut := L_28
          | L_12 := L_7
          | L_13 := L_8
          | L_19 := L_9
          | L_25 := L_21
          | L_26 := L_22
          |)
         where
         shared event Queue_reset;
         integer Queue_cnt;
         integer Queue_r;
         shared integer Queue_w;
         boolean L_28;
         boolean L_26;
         boolean L_25;
         SharedData_TIME L_23;
         boolean L_22;
         boolean L_21;
         boolean L_19;
         boolean L_18;
         boolean L_17;
         boolean L_15;
         boolean L_13;
         boolean L_12;
         SharedData_TIME L_10;
         boolean L_9;
         boolean L_8;
         boolean L_7;
         boolean L_5;
         boolean L_4;
         process prProdCons_others_Process_behavior =
              ( )
            (| (| |) |)
         %prProdCons_others_Process_behavior%; 
         process prProdCons_others_Process_property =
              ( )
            (| (| |) |)
         %prProdCons_others_Process_property%; 
         process thProducer_others_Thread =
              ( ? boolean pProdStart;
                  boolean pProdStop;
                  CTL1 ctl1;
                  thProducer_TIME_EVENT time1;
                  event top;
                ! boolean pProdStartTimer;
                  boolean pProdStopTimer;
                  boolean pMsgSend;
                  SharedData_TIME pQueueNbItem;
                  CTL2 ctl2;
                  boolean Alarm;
              )
            (| l_pProdStart := pProdStart_InEventPort{1, 1}(time1.pProdStart_Frozen_time_event, pProdStart, ctl1.Dispatch)
             | l_pProdStart ^= Start
             | l_pProdStop := pProdStop_InEventPort{1, 1}(time1.pProdStop_Frozen_time_event, pProdStop, ctl1.Dispatch)
             | l_pProdStop ^= Start
             | pProdStartTimer := pProdStartTimer_OutEventPort{1}(time1.pProdStartTimer_Output_time_event, l_pProdStartTimer, ctl2.Complete)
             | pProdStopTimer := pProdStopTimer_OutEventPort{1}(time1.pProdStopTimer_Output_time_event, l_pProdStopTimer, ctl2.Complete)
             | pMsgSend := pMsgSend_OutEventPort{1}(time1.pMsgSend_Output_time_event, l_pMsgSend, ctl2.Complete)
             | (l_pProdStartTimer, l_pProdStopTimer, l_pMsgSend, pQueueNbItem, ctl2) := thProducer_others_Thread_behavior{}(l_pProdStart, l_pProdStop, ctl1.Dispatch, Start, ctl1.Resume)
             | (Start, Alarm) := thProducer_others_Thread_property{}(ctl1, top)
             |)
            where 
            event Start;
            boolean l_pMsgSend;
            boolean l_pProdStopTimer;
            boolean l_pProdStartTimer;
            boolean l_pProdStop;
            boolean l_pProdStart;
            process pProdStart_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pProdStart_InEventPort_behavior{size, dequeue_number, "pProdStart"}(write_flow, Frozen_time_event)
                | pProdStart_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pProdStart_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pProdStart_InEventPort_behavior%; 
               process pProdStart_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pProdStart_InEventPort_Property%; 
               end
            %pProdStart_InEventPort%; 
            process pProdStop_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pProdStop_InEventPort_behavior{size, dequeue_number, "pProdStop"}(write_flow, Frozen_time_event)
                | pProdStop_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pProdStop_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pProdStop_InEventPort_behavior%; 
               process pProdStop_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pProdStop_InEventPort_Property%; 
               end
            %pProdStop_InEventPort%; 
            process pProdStartTimer_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pProdStartTimer_OutEventPort_behavior{size, "pProdStartTimer"}(write_flow, Output_time_event)
                | pProdStartTimer_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pProdStartTimer_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pProdStartTimer_OutEventPort_behavior%; 
               process pProdStartTimer_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pProdStartTimer_OutEventPort_Property%; 
               end
            %pProdStartTimer_OutEventPort%; 
            process pProdStopTimer_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pProdStopTimer_OutEventPort_behavior{size, "pProdStopTimer"}(write_flow, Output_time_event)
                | pProdStopTimer_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pProdStopTimer_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pProdStopTimer_OutEventPort_behavior%; 
               process pProdStopTimer_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pProdStopTimer_OutEventPort_Property%; 
               end
            %pProdStopTimer_OutEventPort%; 
            process pMsgSend_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pMsgSend_OutEventPort_behavior{size, "pMsgSend"}(write_flow, Output_time_event)
                | pMsgSend_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pMsgSend_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pMsgSend_OutEventPort_behavior%; 
               process pMsgSend_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pMsgSend_OutEventPort_Property%; 
               end
            %pMsgSend_OutEventPort%; 
         process thProducer_others_Thread_behavior =
                 ( ? boolean pProdStart;
                     boolean pProdStop;
                     event Dispatch;
                     event Start;
                     event Resume;
                   ! boolean pProdStartTimer;
                     boolean pProdStopTimer;
                     boolean pMsgSend;
                     SharedData_TIME pQueueNbItem;
                     CTL2 ctl2;
                 )
           (| ctl2.Error := ^0
            | pQueueNbItem.TRead :=  ^0 % when Start% % MODIF xxxxxxxxxx%
            | pQueueNbItem.TWrite :=  ^queueItem % when Start% % MODIF xxxxxxxxxx%
            | (pMsgSend, pProdStartTimer, pProdStopTimer, ctl2.Complete, pQueueNbItem.TReset, queueItem) := thProducer_Automaton{QueueSize} (Start, when pProdStart, when pProdStop, Queue_cnt)
            | Queue_w ::= queueItem
            |)
           where 
             integer queueItem;
           end;
            process thProducer_others_Thread_property =
                 ( ? CTL1 ctl1;
                     event top;
                   ! event Start;
                     boolean Alarm;
                 )
               (| Start := when ((ctl1.Resume from ctl1.Dispatch)=1)
                | Alarm := PeriodicDispatch_constraint{10}(top, ctl1.Dispatch)
                | Dispatch_Protocol_property{Supported_Dispatch_Protocols#Periodic}()
                | Period_property{Time_Units#ms, 10}()
                | Deadline_property{Time_Units#ms, 10}()
                |)
            %thProducer_others_Thread_property%; 
            end
         %thProducer_others_Thread%; 
         process thProdTimer_others_Thread =
              ( ? boolean pProdStart;
                  boolean pProdStop;
                  CTL1 ctl1;
                  thProdTimer_TIME_EVENT time1;
                  event top;
                ! boolean pTimeOut;
                  CTL2 ctl2;
                  boolean Alarm;
              )
            (| l_pProdStart := pProdStart_InEventPort{1, 1}(time1.pProdStart_Frozen_time_event, pProdStart, ctl1.Dispatch)
             | l_pProdStart ^= Start
             | l_pProdStop := pProdStop_InEventPort{1, 1}(time1.pProdStop_Frozen_time_event, pProdStop, ctl1.Dispatch)
             | l_pProdStop ^= Start
             | pTimeOut := pTimeOut_OutEventPort{1}(time1.pTimeOut_Output_time_event, l_pTimeOut, ctl2.Complete)
             | (l_pTimeOut, ctl2) := thProdTimer_others_Thread_behavior{}(l_pProdStart, l_pProdStop, ctl1.Dispatch, Start, ctl1.Resume)
             | (Start, Alarm) := thProdTimer_others_Thread_property{}(ctl1, top)
             |)
            where 
            event Start;
            boolean l_pTimeOut;
            boolean l_pProdStop;
            boolean l_pProdStart;
            shared integer timerValue;
            process pProdStart_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pProdStart_InEventPort_behavior{size, dequeue_number, "pProdStart"}(write_flow, Frozen_time_event)
                | pProdStart_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pProdStart_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pProdStart_InEventPort_behavior%; 
               process pProdStart_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pProdStart_InEventPort_Property%; 
               end
            %pProdStart_InEventPort%; 
            process pProdStop_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pProdStop_InEventPort_behavior{size, dequeue_number, "pProdStop"}(write_flow, Frozen_time_event)
                | pProdStop_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pProdStop_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pProdStop_InEventPort_behavior%; 
               process pProdStop_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pProdStop_InEventPort_Property%; 
               end
            %pProdStop_InEventPort%; 
            process pTimeOut_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pTimeOut_OutEventPort_behavior{size, "pTimeOut"}(write_flow, Output_time_event)
                | pTimeOut_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pTimeOut_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pTimeOut_OutEventPort_behavior%; 
               process pTimeOut_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pTimeOut_OutEventPort_Property%; 
               end
            %pTimeOut_OutEventPort%; 
            process thProdTimer_others_Thread_behavior =
                 ( ? boolean pProdStart;
                     boolean pProdStop;
                     event Dispatch;
                     event Start;
                     event Resume;
                   ! boolean pTimeOut;
                     CTL2 ctl2;
                 )
              (| ctl2.Error := ^0
               | (pTimeOut, ctl2.Complete) := Timer_Automaton{6000}(Start, when pProdStart, when pProdStop)
               |)
            %thProdTimer_others_Thread_behavior%; 
            process thProdTimer_others_Thread_property =
                 ( ? CTL1 ctl1;
                     event top;
                   ! event Start;
                     boolean Alarm;
                 )
               (| Start := when ((ctl1.Resume from ctl1.Dispatch)=1)
                | Alarm := PeriodicDispatch_constraint{10}(top, ctl1.Dispatch)
                | Dispatch_Protocol_property{Supported_Dispatch_Protocols#Periodic}()
                | Period_property{Time_Units#ms, 10}()
                | Deadline_property{Time_Units#ms, 10}()
                |)
            %thProdTimer_others_Thread_property%; 
            end
         %thProdTimer_others_Thread%; 
         process thConsumer_others_Thread =
              ( ? boolean pConsStop;
                  boolean pConsStart;
                  boolean pMsgRecv;
                  CTL1 ctl1;
                  thConsumer_TIME_EVENT time1;
                  event top;
                ! boolean pConsStartTimer;
                  boolean pConsStopTimer;
                  SharedData_TIME pQueueNbItem;
                  CTL2 ctl2;
                  boolean Alarm;
              )
            (| l_pConsStop := pConsStop_InEventPort{1, 1}(time1.pConsStop_Frozen_time_event, pConsStop, ctl1.Dispatch)
             | l_pConsStop ^= Start
             | l_pConsStart := pConsStart_InEventPort{1, 1}(time1.pConsStart_Frozen_time_event, pConsStart, ctl1.Dispatch)
             | l_pConsStart ^= Start
             | l_pMsgRecv := pMsgRecv_InEventPort{1, 1}(time1.pMsgRecv_Frozen_time_event, pMsgRecv, ctl1.Dispatch)
             | l_pMsgRecv ^= Start
             | pConsStartTimer := pConsStartTimer_OutEventPort{1}(time1.pConsStartTimer_Output_time_event, l_pConsStartTimer, ctl2.Complete)
             | pConsStopTimer := pConsStopTimer_OutEventPort{1}(time1.pConsStopTimer_Output_time_event, l_pConsStopTimer, ctl2.Complete)
             | (l_pConsStartTimer, l_pConsStopTimer, pQueueNbItem, ctl2) := thConsumer_others_Thread_behavior{}(l_pConsStop, l_pConsStart, l_pMsgRecv, ctl1.Dispatch, Start, ctl1.Resume)
             | (Start, Alarm) := thConsumer_others_Thread_property{}(ctl1, top)
             |)
            where 
            event Start;
            boolean l_pConsStopTimer;
            boolean l_pConsStartTimer;
            boolean l_pMsgRecv;
            boolean l_pConsStart;
            boolean l_pConsStop;
            process pConsStop_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pConsStop_InEventPort_behavior{size, dequeue_number, "pConsStop"}(write_flow, Frozen_time_event)
                | pConsStop_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pConsStop_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pConsStop_InEventPort_behavior%; 
               process pConsStop_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pConsStop_InEventPort_Property%; 
               end
            %pConsStop_InEventPort%; 
            process pConsStart_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pConsStart_InEventPort_behavior{size, dequeue_number, "pConsStart"}(write_flow, Frozen_time_event)
                | pConsStart_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pConsStart_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pConsStart_InEventPort_behavior%; 
               process pConsStart_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pConsStart_InEventPort_Property%; 
               end
            %pConsStart_InEventPort%; 
            process pMsgRecv_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pMsgRecv_InEventPort_behavior{size, dequeue_number, "pMsgRecv"}(write_flow, Frozen_time_event)
                | pMsgRecv_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pMsgRecv_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pMsgRecv_InEventPort_behavior%; 
               process pMsgRecv_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pMsgRecv_InEventPort_Property%; 
               end
            %pMsgRecv_InEventPort%; 
            process pConsStartTimer_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pConsStartTimer_OutEventPort_behavior{size, "pConsStartTimer"}(write_flow, Output_time_event)
                | pConsStartTimer_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pConsStartTimer_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pConsStartTimer_OutEventPort_behavior%; 
               process pConsStartTimer_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pConsStartTimer_OutEventPort_Property%; 
               end
            %pConsStartTimer_OutEventPort%; 
            process pConsStopTimer_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pConsStopTimer_OutEventPort_behavior{size, "pConsStopTimer"}(write_flow, Output_time_event)
                | pConsStopTimer_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pConsStopTimer_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pConsStopTimer_OutEventPort_behavior%; 
               process pConsStopTimer_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pConsStopTimer_OutEventPort_Property%; 
               end
            %pConsStopTimer_OutEventPort%; 
         process thConsumer_others_Thread_behavior =
                 ( ? boolean pConsStop;
                     boolean pConsStart;
                     boolean pMsgRecv;
                     event Dispatch;
                     event Start;
                     event Resume;
                   ! boolean pConsStartTimer;
                     boolean pConsStopTimer;
                     SharedData_TIME pQueueNbItem;
                     CTL2 ctl2;
                 )
               (| ctl2.Error := ^0
                | pQueueNbItem.TWrite := ^0 %   when Start % %  modif LBesnard%
                | pQueueNbItem.TReset := ^0
                | (pConsStartTimer, pConsStopTimer, ctl2.Complete, pQueueNbItem.TRead) := thConsumer_Automaton(Start, when pConsStart, when pConsStop, when pMsgRecv, Queue_cnt)
                |)
            %thConsumer_others_Thread_behavior%; 
            process thConsumer_others_Thread_property =
                 ( ? CTL1 ctl1;
                     event top;
                   ! event Start;
                     boolean Alarm;
                 )
               (| Start := when ((ctl1.Resume from ctl1.Dispatch)=1)
                | Alarm := PeriodicDispatch_constraint{10}(top, ctl1.Dispatch)
                | Dispatch_Protocol_property{Supported_Dispatch_Protocols#Periodic}()
                | Period_property{Time_Units#ms, 10}()
                | Deadline_property{Time_Units#ms, 10}()
                |)
            %thConsumer_others_Thread_property%; 
            end
         %thConsumer_others_Thread%; 
         process thConsTimer_others_Thread =
              ( ? boolean pConsStart;
                  boolean pConsStop;
                  CTL1 ctl1;
                  thConsTimer_TIME_EVENT time1;
                  event top;
                ! boolean pTimeOut;
                  CTL2 ctl2;
                  boolean Alarm;
              )
            (| l_pConsStart := pConsStart_InEventPort{1, 1}(time1.pConsStart_Frozen_time_event, pConsStart, ctl1.Dispatch)
             | l_pConsStart ^= Start
             | l_pConsStop := pConsStop_InEventPort{1, 1}(time1.pConsStop_Frozen_time_event, pConsStop, ctl1.Dispatch)
             | l_pConsStop ^= Start
             | pTimeOut := pTimeOut_OutEventPort{1}(time1.pTimeOut_Output_time_event, l_pTimeOut, ctl2.Complete)
             | (l_pTimeOut, ctl2) := thConsTimer_others_Thread_behavior{}(l_pConsStart, l_pConsStop, ctl1.Dispatch, Start, ctl1.Resume)
             | (Start, Alarm) := thConsTimer_others_Thread_property{}(ctl1, top)
             |)
            where 
            event Start;
            boolean l_pTimeOut;
            boolean l_pConsStop;
            boolean l_pConsStart;
            shared integer timerValue;
            process pConsStart_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pConsStart_InEventPort_behavior{size, dequeue_number, "pConsStart"}(write_flow, Frozen_time_event)
                | pConsStart_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pConsStart_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pConsStart_InEventPort_behavior%; 
               process pConsStart_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pConsStart_InEventPort_Property%; 
               end
            %pConsStart_InEventPort%; 
            process pConsStop_InEventPort =
                 { integer size;
                   integer dequeue_number; }
                 ( ? event Frozen_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean read_flow;
                 )
               (| read_flow := pConsStop_InEventPort_behavior{size, dequeue_number, "pConsStop"}(write_flow, Frozen_time_event)
                | pConsStop_InEventPort_Property{}(Frozen_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pConsStop_InEventPort_behavior =
                    { integer size;
                      integer dequeue_number;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Frozen_time_event;
                      ! boolean read_flow;
                    )
                  (| read_flow := InEventPort_Behavior{size, dequeue_number, port_name}(write_flow, Frozen_time_event) |)
               %pConsStop_InEventPort_behavior%; 
               process pConsStop_InEventPort_Property =
                    ( ? event Frozen_time_event;
                        event Reference_time_event;
                    )
                  (| Input_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Frozen_time_event, Reference_time_event)
                   | Overflow_Handling_Protocol_property{Overflow_Handling_Protocol#DropOldest}()
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   | Dequeued_Items_property{1}()
                   | Dequeue_Protocol_property{Dequeue_Protocol#OneItem}()
                   |)
               %pConsStop_InEventPort_Property%; 
               end
            %pConsStop_InEventPort%; 
            process pTimeOut_OutEventPort =
                 { integer size; }
                 ( ? event Output_time_event;
                     boolean write_flow;
                     event Reference_time_event;
                   ! boolean sent_flow;
                 )
               (| sent_flow := pTimeOut_OutEventPort_behavior{size, "pTimeOut"}(write_flow, Output_time_event)
                | pTimeOut_OutEventPort_Property{}(Output_time_event, Reference_time_event)
                |)
               where 
               use AADL_MSGTYPE_boolean, AADL_EVENTPORT; 
               process pTimeOut_OutEventPort_behavior =
                    { integer size;
                      string port_name; }
                    ( ? boolean write_flow;
                        event Output_time_event;
                      ! boolean sent_flow;
                    )
                  (| sent_flow := OutEventPort_Behavior{size, port_name}(write_flow, Output_time_event) |)
               %pTimeOut_OutEventPort_behavior%; 
               process pTimeOut_OutEventPort_Property =
                    ( ? event Output_time_event;
                        event Reference_time_event;
                    )
                  (| Output_Time_property{Time_Units#ns, Time_Units#ns, 0.0, 0.0}(Output_time_event, Reference_time_event)
                   | Queue_Size_property{1}()
                   | Queue_Processing_Protocol_property{Queue_Processing_Protocol#FIFO}()
                   |)
               %pTimeOut_OutEventPort_Property%; 
               end
            %pTimeOut_OutEventPort%; 
            process thConsTimer_others_Thread_behavior =
                 ( ? boolean pConsStart;
                     boolean pConsStop;
                     event Dispatch;
                     event Start;
                     event Resume;
                   ! boolean pTimeOut;
                     CTL2 ctl2;
                 )
             (| ctl2.Error := ^0
                | (pTimeOut, ctl2.Complete) := Timer_Automaton{6000}(Start, when pConsStart, when pConsStop)
                |)
            %thConsTimer_others_Thread_behavior%; 
            process thConsTimer_others_Thread_property =
                 ( ? CTL1 ctl1;
                     event top;
                   ! event Start;
                     boolean Alarm;
                 )
               (| Start := when ((ctl1.Resume from ctl1.Dispatch)=1)
                | Alarm := PeriodicDispatch_constraint{10}(top, ctl1.Dispatch)
                | Dispatch_Protocol_property{Supported_Dispatch_Protocols#Periodic}()
                | Period_property{Time_Units#ms, 10}()
                | Deadline_property{Time_Units#ms, 10}()
                |)
            %thConsTimer_others_Thread_property%; 
            end
         %thConsTimer_others_Thread%; 
         end
      %prProdCons_others_Process%; 
      process Processor1_Processor =
           { process TT_prProdCons_others_Process prProdCons; }
           ( ? event top;
               boolean prProdCons_pStart;
               boolean prProdCons_pStop;
             ! boolean prProdCons_pProdTimeOut;
               boolean prProdCons_pConsTimeOut;
           )
         (| (L_33, L_34, prProdCons_thProducer_ctl2, prProdCons_thProducer_Alarm, prProdCons_thProdTimer_ctl2, prProdCons_thProdTimer_Alarm, prProdCons_thConsumer_ctl2, prProdCons_thConsumer_Alarm, prProdCons_thConsTimer_ctl2, prProdCons_thConsTimer_Alarm)
            := prProdCons{}(top, L_31, L_32, prProdCons_thProducer_ctl1, prProdCons_thProducer_time1, prProdCons_thProdTimer_ctl1, prProdCons_thProdTimer_time1, prProdCons_thConsumer_ctl1, prProdCons_thConsumer_time1, prProdCons_thConsTimer_ctl1, 
                            prProdCons_thConsTimer_time1)
          | Processor1_Processor_Behavior{}
          | Processor1_Processor_property{}
          | L_31 := prProdCons_pStart
          | L_32 := prProdCons_pStop
          | prProdCons_pProdTimeOut := L_33
          | prProdCons_pConsTimeOut := L_34
          |)
         where 
         thConsTimer_TIME_EVENT prProdCons_thConsTimer_time1;
         CTL1 prProdCons_thConsTimer_ctl1;
         thConsumer_TIME_EVENT prProdCons_thConsumer_time1;
         CTL1 prProdCons_thConsumer_ctl1;
         thProdTimer_TIME_EVENT prProdCons_thProdTimer_time1;
         CTL1 prProdCons_thProdTimer_ctl1;
         thProducer_TIME_EVENT prProdCons_thProducer_time1;
         CTL1 prProdCons_thProducer_ctl1;
         boolean prProdCons_thConsTimer_Alarm;
         CTL2 prProdCons_thConsTimer_ctl2;
         boolean prProdCons_thConsumer_Alarm;
         CTL2 prProdCons_thConsumer_ctl2;
         boolean prProdCons_thProdTimer_Alarm;
         CTL2 prProdCons_thProdTimer_ctl2;
         boolean prProdCons_thProducer_Alarm;
         CTL2 prProdCons_thProducer_ctl2;
         boolean L_34;
         boolean L_33;
         boolean L_32;
         boolean L_31;
         process Processor1_Processor_Behavior =
              ( ? event top;
                  CTL2 prProdCons_thProducer_ctl2;
                  boolean prProdCons_thProducer_Alarm;
                  CTL2 prProdCons_thProdTimer_ctl2;
                  boolean prProdCons_thProdTimer_Alarm;
                  CTL2 prProdCons_thConsumer_ctl2;
                  boolean prProdCons_thConsumer_Alarm;
                  CTL2 prProdCons_thConsTimer_ctl2;
                  boolean prProdCons_thConsTimer_Alarm;
                ! CTL1 prProdCons_thProducer_ctl1;
                  thProducer_TIME_EVENT prProdCons_thProducer_time1;
                  CTL1 prProdCons_thProdTimer_ctl1;
                  thProdTimer_TIME_EVENT prProdCons_thProdTimer_time1;
                  CTL1 prProdCons_thConsumer_ctl1;
                  thConsumer_TIME_EVENT prProdCons_thConsumer_time1;
                  CTL1 prProdCons_thConsTimer_ctl1;
                  thConsTimer_TIME_EVENT prProdCons_thConsTimer_time1;
              )
            (| (prProdCons_thProducer_ctl1.Dispatch, prProdCons_thProdTimer_ctl1.Dispatch, prProdCons_thConsumer_ctl1.Dispatch, prProdCons_thConsTimer_ctl1.Dispatch) := Sim_Dispatch_Periodic{4,8,6,8, 0,2,1,6}(top)
             | (prProdCons_thProducer_ctl1.Resume, prProdCons_thProdTimer_ctl1.Resume, prProdCons_thConsumer_ctl1.Resume, prProdCons_thConsTimer_ctl1.Resume) := Sim_Resume{}(top, prProdCons_thProducer_ctl1.Dispatch, prProdCons_thProdTimer_ctl1.Dispatch, 
                                             prProdCons_thConsumer_ctl1.Dispatch, prProdCons_thConsTimer_ctl1.Dispatch)
             | (prProdCons_thProducer_ctl1.Deadline, prProdCons_thProdTimer_ctl1.Deadline, prProdCons_thConsumer_ctl1.Deadline, prProdCons_thConsTimer_ctl1.Deadline) := Sim_Deadline{}(top, prProdCons_thProducer_ctl1.Dispatch, prProdCons_thProdTimer_ctl1.
                                             Dispatch, prProdCons_thConsumer_ctl1.Dispatch, prProdCons_thConsTimer_ctl1.Dispatch)
             | (prProdCons_thProducer_ctl1.Initialize, prProdCons_thProdTimer_ctl1.Initialize, prProdCons_thConsumer_ctl1.Initialize, prProdCons_thConsTimer_ctl1.Initialize) := Sim_Initialize{}(top, prProdCons_thProducer_ctl1.Dispatch, 
                                             prProdCons_thProdTimer_ctl1.Dispatch, prProdCons_thConsumer_ctl1.Dispatch, prProdCons_thConsTimer_ctl1.Dispatch)
             | Sim_TimeEvent{}
             |)
            where 
                process Sim_Dispatch_Periodic =
                 { integer p0, p1, p2,p3;
                   integer phi0, phi1, phi2, phi3;}                   
                 ( ? event top;
                   ! event d0;
                     event d1;
                     event d2;
                     event d3;
                 )
               (| d0 := affine_sample{phi0, p0}(top) 
                | d1 := affine_sample{phi1, p1}(top)
                | d2 := affine_sample{phi2, p2}(top)
                | d3 := affine_sample{phi3, p3}(top)
	        | printTasks( left_tt(d0, top), left_tt(d2, top), left_tt(d1, top), left_tt(d3, top))
                |)
            %Sim_Dispatch_Periodic%; 
            process Sim_Resume =
                 ( ? event top;
                     event dispatch0;
                     event dispatch1;
                     event dispatch2;
                     event dispatch3;
                   ! event resume0;
                     event resume1;
                     event resume2;
                     event resume3;
                 )
               (| resume0 := dispatch0
                | resume1 := dispatch1
                | resume2 := dispatch2
                | resume3 := dispatch3
                |)
            %Sim_Resume%; 
            process Sim_Deadline =
                 ( ? event top;
                     event dispatch0;
                     event dispatch1;
                     event dispatch2;
                     event dispatch3;
                   ! event deadline0;
                     event deadline1;
                     event deadline2;
                     event deadline3;
                 )
               (| deadline0 := dispatch0
                | deadline1 := dispatch1
                | deadline2 := dispatch2
                | deadline3 := dispatch3
                |)
            %Sim_Deadline%; 
            process Sim_Initialize =
                 ( ? event top;
                     event dispatch0;
                     event dispatch1;
                     event dispatch2;
                     event dispatch3;
                   ! event init0;
                     event init1;
                     event init2;
                     event init3;
                 )
               (| init0 := ^0
                | init1 := ^0
                | init2 := ^0
                | init3 := ^0
                |)
            %Sim_Initialize%; 
            process Sim_TimeEvent =
                 ( ? event top;
                     CTL1 prProdCons_thProducer_ctl1;
                     CTL1 prProdCons_thProdTimer_ctl1;
                     CTL1 prProdCons_thConsumer_ctl1;
                     CTL1 prProdCons_thConsTimer_ctl1;
                     CTL2 prProdCons_thProducer_ctl2;
                     CTL2 prProdCons_thProdTimer_ctl2;
                     CTL2 prProdCons_thConsumer_ctl2;
                     CTL2 prProdCons_thConsTimer_ctl2;
                   ! thProducer_TIME_EVENT prProdCons_thProducer_time1;
                     thProdTimer_TIME_EVENT prProdCons_thProdTimer_time1;
                     thConsumer_TIME_EVENT prProdCons_thConsumer_time1;
                     thConsTimer_TIME_EVENT prProdCons_thConsTimer_time1;
                 )
               (| prProdCons_thProducer_time1.pProdStart_Frozen_time_event := prProdCons_thProducer_ctl1.Dispatch
                | prProdCons_thProducer_time1.pProdStop_Frozen_time_event := prProdCons_thProducer_ctl1.Dispatch
                | prProdCons_thProducer_time1.pProdStartTimer_Output_time_event := prProdCons_thProducer_ctl2.Complete
                | prProdCons_thProducer_time1.pProdStopTimer_Output_time_event := prProdCons_thProducer_ctl2.Complete
                | prProdCons_thProducer_time1.pMsgSend_Output_time_event := prProdCons_thProducer_ctl2.Complete
                | prProdCons_thProdTimer_time1.pProdStart_Frozen_time_event := prProdCons_thProdTimer_ctl1.Dispatch
                | prProdCons_thProdTimer_time1.pProdStop_Frozen_time_event := prProdCons_thProdTimer_ctl1.Dispatch
                | prProdCons_thProdTimer_time1.pTimeOut_Output_time_event := prProdCons_thProdTimer_ctl2.Complete
                | prProdCons_thConsumer_time1.pConsStop_Frozen_time_event := prProdCons_thConsumer_ctl1.Dispatch
                | prProdCons_thConsumer_time1.pConsStart_Frozen_time_event := prProdCons_thConsumer_ctl1.Dispatch
                | prProdCons_thConsumer_time1.pMsgRecv_Frozen_time_event := prProdCons_thConsumer_ctl1.Dispatch
                | prProdCons_thConsumer_time1.pConsStartTimer_Output_time_event := prProdCons_thConsumer_ctl2.Complete
                | prProdCons_thConsumer_time1.pConsStopTimer_Output_time_event := prProdCons_thConsumer_ctl2.Complete
                | prProdCons_thConsTimer_time1.pConsStart_Frozen_time_event := prProdCons_thConsTimer_ctl1.Dispatch
                | prProdCons_thConsTimer_time1.pConsStop_Frozen_time_event := prProdCons_thConsTimer_ctl1.Dispatch
                | prProdCons_thConsTimer_time1.pTimeOut_Output_time_event := prProdCons_thConsTimer_ctl2.Complete
                |)
            %Sim_TimeEvent%; 
            end
         %Processor1_Processor_Behavior%; 
         process Processor1_Processor_property =
              ( )
            (| (| |) |)
         %Processor1_Processor_property%; 
         end
      %Processor1_Processor%; 
      end
   %ProducerConsumer_others_System%; 
end %ProducerConsumer%; 
