package fr.inria.tea.aadl2ssme.scheduling.actions;

import java.util.ArrayList;
import java.util.Iterator;

import fr.inria.tea.aadl2ssme.scheduling.idstruct.*;


public class Dependency_Scheduling {
		/**
		 * The constructor.
		 */
		I_Process iProcess;
		boolean bShowProgress = false;
		public Dependency_Scheduling() {
		}
		public Dependency_Scheduling(I_Process curProcess, boolean bProgress) {
			iProcess = curProcess;
			bShowProgress = bProgress;
		}
		public ArrayList<AL_ThreadInstance> CreateDependencyThreadInstanceList(){
			//make a ordered list of all threads (thread instance) according to the scheduling policy
			ArrayList<AL_ThreadInstance> alTI = new ArrayList<AL_ThreadInstance>();
			//ArrayList<Integer> alTIIndex = new ArrayList<Integer>();
			//First step
			//if Dependency first, check deadline and set deadline
			//set deadline for each instance
			//sort all the instances
			
//			for (int ii =0 ; ii< iProcess.threadLists.size(); ii++){
//				alTIIndex.add(0);
//			}
			
			//build the list for the next thread instances for scheduling 
			
			ArrayList<I_ThreadInstance> newTIListForScheduling = new ArrayList<I_ThreadInstance>();
			
			for (int ii =0 ; ii< iProcess.threadLists.size(); ii++){
				newTIListForScheduling.add(iProcess.threadLists.get(ii).threadInstanceList.get(0));
			}

			AL_ThreadInstance newThreadInstanceList;
			boolean isLoop = true;
			
			while (isLoop){
				//get a thread instance from the candidate list
				newThreadInstanceList = getThreadInstanceForScheduling(newTIListForScheduling);
				if (newThreadInstanceList ==null) return null;
				alTI.add(newThreadInstanceList);
				//remove the cho
				replaceITICPO(newTIListForScheduling, newThreadInstanceList);
				if (newTIListForScheduling.size()==0) isLoop = false;
			}
			return alTI;
		}
		
		public void replaceITICPO(ArrayList<I_ThreadInstance> alITI, AL_ThreadInstance alThreadInstance){
			//alITI: the list to be scheduled
			//alThreadInstance: the chosen thread instance, to be replaced
			for (int i=0;i<alThreadInstance.threadInstanceList.size();i++){
				if (alITI.contains(alThreadInstance.threadInstanceList.get(i))){
					alITI.remove(alThreadInstance.threadInstanceList.get(i));
					int nextIndex = (alThreadInstance.threadInstanceList.get(i).instanceNumber+1);
					if (nextIndex < alThreadInstance.threadInstanceList.get(i).iThread.threadInstanceList.size()){
						alITI.add(alThreadInstance.threadInstanceList.get(i).iThread.threadInstanceList.get(nextIndex));	
					}
				}
			}
		}
		public AL_ThreadInstance getThreadInstanceForScheduling(ArrayList<I_ThreadInstance> originalTIList){
			AL_ThreadInstance resultThreadInstanceList = new AL_ThreadInstance();
			I_ThreadInstance iThreadInstance;
			ArrayList<I_ThreadInstance> toRemoveTIListForScheduling = new ArrayList<I_ThreadInstance>();
			
			int i = 0;
			for (i=0;i<originalTIList.size();i++){
				resultThreadInstanceList.threadInstanceList.add(originalTIList.get(i));
			}
			//getEarliestStartTIList() //remove instances whose "start" is later than any deadlines
			int earliestDeadline = 0;
			for (i=0;i<originalTIList.size();i++){
				iThreadInstance = resultThreadInstanceList.threadInstanceList.get(i);
				if (earliestDeadline == 0){
					earliestDeadline = iThreadInstance.period*(iThreadInstance.instanceNumber+1);
				}
				if (earliestDeadline > (iThreadInstance.period*(iThreadInstance.instanceNumber+1))){
					earliestDeadline = iThreadInstance.period*(iThreadInstance.instanceNumber+1);
				}
				
			}	

			
			Iterator<I_ThreadInstance> itThreadInstanceList1 = resultThreadInstanceList.threadInstanceList.iterator();
			while(itThreadInstanceList1.hasNext()){		
				iThreadInstance = itThreadInstanceList1.next();//listThreadInstance.threadInstanceList.get(i);
				if (earliestDeadline < (iThreadInstance.period*iThreadInstance.instanceNumber)){
					toRemoveTIListForScheduling.add(iThreadInstance);
					//originalTIList.remove(iThreadInstance);
				}
			}	
			
			for (i=0;i<toRemoveTIListForScheduling.size();i++){
				resultThreadInstanceList.threadInstanceList.remove(toRemoveTIListForScheduling.get(i));
				//originalTIList.remove(toRemoveTIListForScheduling.get(i));
			}			
			
			//getEarliestDependency() // remove instances which is successors of instances in current list
			Iterator<I_ThreadInstance> itThreadInstanceList2 = resultThreadInstanceList.threadInstanceList.iterator();

			while(itThreadInstanceList2.hasNext()){		
				iThreadInstance = itThreadInstanceList2.next();//listThreadInstance.threadInstanceList.get(i);
				if (isDirectSuccessor(resultThreadInstanceList.threadInstanceList, iThreadInstance)){
					toRemoveTIListForScheduling.add(iThreadInstance);
				}
			}		
			
			for (i=0;i<toRemoveTIListForScheduling.size();i++){
				resultThreadInstanceList.threadInstanceList.remove(toRemoveTIListForScheduling.get(i));
				//originalTIList.remove(toRemoveTIListForScheduling.get(i));
			}
			
			if (resultThreadInstanceList.threadInstanceList.size()==0){
				return null;
			}
			
			//getEarliestDeadline()  //remove instance with latest deadlines
			ArrayList<I_ThreadInstance> orderedTIListForScheduling = new ArrayList<I_ThreadInstance>();
			Iterator<I_ThreadInstance>  itThreadInstanceList3 = resultThreadInstanceList.threadInstanceList.iterator();
			while(itThreadInstanceList3.hasNext()){		
				iThreadInstance = itThreadInstanceList3.next();
				if (orderedTIListForScheduling.size()==0){
					orderedTIListForScheduling.add(iThreadInstance);
				} else {
					insertOrderedThreadInstance(orderedTIListForScheduling, iThreadInstance);
				}
			}
			resultThreadInstanceList.threadInstanceList = orderedTIListForScheduling;
			return resultThreadInstanceList;
		}
		
		public void insertOrderedThreadInstance(ArrayList<I_ThreadInstance> listTI, I_ThreadInstance iThreadInstance){
			for (int i=0;i<listTI.size();i++){
				if (iThreadInstance.deadlineMSTAIndex <= listTI.get(i).deadlineMSTAIndex){
					listTI.add(i, iThreadInstance);
					return;
				}
			}
			listTI.add(iThreadInstance);
			return;
		}
		public boolean isDirectSuccessor(ArrayList<I_ThreadInstance> listTI, I_ThreadInstance iThreadInstance){
			L_Thread lThread;
			for (int i=0; i<listTI.size();i++){
				lThread = listTI.get(i).iThread.lThread;
				for (int j=0; j<iThreadInstance.iThread.lThread.inPortList.size();j++){
					if (lThread == iThreadInstance.iThread.lThread.inPortList.get(j).srcThread){
						return true;
					}
				}
			}
			return false;
		}
		
		public boolean isDirectPrecedencer(ArrayList<I_ThreadInstance> listTI, I_ThreadInstance iThreadInstance){
			L_Thread lThread;
			for (int i=0; i<listTI.size();i++){
				lThread = listTI.get(i).iThread.lThread;
				for (int j=0; j<lThread.inPortList.size();j++){
					if (iThreadInstance.iThread.lThread == lThread.inPortList.get(j).srcThread){
						return true;
					}
				}
			}
			return false;
		}
		
		public int locateTIInSQ(ArrayList<Integer> indexList, I_ThreadInstance iTICPO){
			//get the index number of 
			int value = 0;
			int deadline = iTICPO.deadlineMSTAIndex;
			if (indexList.size() < 1) {
				return 0;
			}
			for (int p=0; p<indexList.size();p++){
				value = indexList.get(p);
				if (deadline == value){
					//the same deadline, so insert in the same position
					return -p;
				} else if (deadline < value) {
					return p;
				} 
			}
			return 0;//add the element in the tail of the queue
		}
		public void showDebugInfo(boolean bShow, String str){
			if (bShow) System.err.println("DI - MA: " + str);		
		}
		public void showProgressInfo(boolean bShow, String str){
			if (bShow) System.out.println("PI - MA: " + str);
		}	
		public ArrayList<I_Thread> getDependentIThread(I_Thread curIThread){
			I_Thread depIThread;
			ArrayList<I_Thread> alIThread = new ArrayList<I_Thread>();
			for (int i=0; i<curIThread.lThread.inPortList.size();i++){
				depIThread = getIThreadFromLThread(curIThread.lThread.inPortList.get(i).srcThread);
				alIThread.add(depIThread);
			}
			return alIThread;
		}
		public I_Thread getIThreadFromLThread(L_Thread lThread){
			for (int i=0; i<iProcess.threadLists.size();i++){
				if (iProcess.threadLists.get(i).lThread == lThread) return iProcess.threadLists.get(i);
			} 
			return null;
		}
}
