package fr.inria.tea.aadl2ssme.scheduling.actions;

import java.util.ArrayList;
import java.util.Iterator;

import fr.inria.tea.aadl2ssme.scheduling.idstruct.*;

public class RM_Scheduling {
		/**
		 * The constructor.
		 */
		I_Process iProcess;
		boolean bShowProgress = false;
		public RM_Scheduling() {
		}
		public RM_Scheduling(I_Process curProcess, boolean bProgress) {
			iProcess = curProcess;
			bShowProgress = bProgress;
		}
		public ArrayList<AL_ThreadInstance> CreateRMThreadInstanceList(){
			//make a ordered list of all threads (thread instance) according to the scheduling policy
			ArrayList<AL_ThreadInstance> alTI = new ArrayList<AL_ThreadInstance>();
			ArrayList<Integer> alTIIndex = new ArrayList<Integer>();
			//First step
			//if EDF, check deadline and set deadline
			//set deadline for each instance
			//sort all the instances
			Iterator<I_Thread> itThreadListCPO = iProcess.threadLists.iterator();
			
			I_Thread iThreadCPO;
			I_ThreadInstance iTICPO;
			int indexCPO = 0;
			while(itThreadListCPO.hasNext()){
				iThreadCPO = itThreadListCPO.next();
				Iterator<I_ThreadInstance> itThreadInstanceCPO = iThreadCPO.threadInstanceList.iterator();
				while(itThreadInstanceCPO.hasNext()){
					iTICPO = itThreadInstanceCPO.next();
					indexCPO = locateTIInSQ(alTIIndex, iTICPO);
					if (indexCPO == 0){ // 
						if (alTIIndex.size() == 0){
							//add a new list and new instance
							AL_ThreadInstance alThreadInstance = new AL_ThreadInstance();
							alThreadInstance.threadInstanceList.add(iTICPO);
							alTI.add(alThreadInstance);
							alTIIndex.add(iTICPO.deadlineMSTAIndex);
						} else if (alTIIndex.size() > 0){
							//already have elements in alTIIndex
							if (iTICPO.deadlineMSTAIndex == alTIIndex.get(0)){
								//only add a new instance
								alTI.get(0).threadInstanceList.add(iTICPO);
							} else if (iTICPO.deadlineMSTAIndex > alTIIndex.get(alTIIndex.size()-1)){
								//add a new list and new instance
								AL_ThreadInstance alThreadInstance = new AL_ThreadInstance();
								alThreadInstance.threadInstanceList.add(iTICPO);
								alTI.add(alThreadInstance);
								alTIIndex.add(iTICPO.deadlineMSTAIndex);
							} else if (iTICPO.deadlineMSTAIndex < alTIIndex.get(0)) {
								// unknown situation
								AL_ThreadInstance alThreadInstance = new AL_ThreadInstance();
								alTI.add(indexCPO, alThreadInstance);
								alThreadInstance.threadInstanceList.add(iTICPO);
								alTIIndex.add(indexCPO, iTICPO.deadlineMSTAIndex);
							}
							
						}
						
					}else if (indexCPO > 0){ ////add a new list and new instance
						AL_ThreadInstance alThreadInstance = new AL_ThreadInstance();
						alTI.add(indexCPO, alThreadInstance);
						alThreadInstance.threadInstanceList.add(iTICPO);
						alTIIndex.add(indexCPO, iTICPO.deadlineMSTAIndex);
					} else { //indexCPO <0
						//only add instance to a existing list
						alTI.get(-indexCPO).threadInstanceList.add(iTICPO);
					}
				}
			}
			showProgressInfo(bShowProgress,"---START---CreatePOrderedThreadInstanceList created");
			String tempStr = new String("");
			for (int iTempStr =0; iTempStr < alTIIndex.size(); iTempStr++){
				tempStr = tempStr + " | " + Integer.toString(alTIIndex.get(iTempStr));
			}
			showProgressInfo(bShowProgress,"---EDF RESULT--ordered deadlines " + tempStr);
			return alTI;
		}
		public int locateTIInSQ(ArrayList<Integer> indexList, I_ThreadInstance iTICPO){
			int value = 0;
			int deadline = iTICPO.deadlineMSTAIndex;
			if (indexList.size() < 1) {
				return 0;
			}
			for (int p=0; p<indexList.size();p++){
				value = indexList.get(p);
				if (deadline == value){
					//the same deadline, so insert in the same position
					return -p;
				} else if (deadline < value) {
					return p;
				} 
			}
			return 0;//add the element in the tail of the queue
		}
		public void showDebugInfo(boolean bShow, String str){
			if (bShow) System.err.println("DI - MA: " + str);		
		}
		public void showProgressInfo(boolean bShow, String str){
			if (bShow) System.out.println("PI - MA: " + str);
		}	
}
