 

/*
 * //////////////////////////////////////////////////////////////////////////
 * //This class simulates the generation of initialize signal
 * //////////////////////////////////////////////////////////////////////////
 */
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import java.util.ArrayList;
import org.osate.aadl2.*;

import org.eclipse.pop.ssme.impl.*;
import org.eclipse.pop.ssme.polychrony.SignalOperators;


 
public class ASME2SSME_Simulate_Initialize extends ASME2SSME_Simulate_Common {
	
	
	/**
	 * Class constructor
	 */
	public ASME2SSME_Simulate_Initialize() {
	}
	
	
	/**
	 * Make a Signal process that simulates the generation of Initialize signals
	 * 
	 * @param n
	 * @return
	 */
	public ProcessModelImpl ASME2SSME_mkSimInitialize(ProcessorSubcomponent subp, ArrayList<ProcessSubcomponent> list1){
		
//		process Sim_Initialize = 
//			(? event top; event dispatch1, dispatch2, ...;
//			 ! event init1, init2, ...; )
//			(| init1 := when (dispatch1 count 10000) = 0
//           | ...
//			 |) external;
		
		Trace("\n ######## ASME2SSME_Simulate_Initialize: ASME2SSME_mkSimInitialize : " + subp.getName());
		signalTreeAPI myLib= new signalTreeAPI();
    	AADLCoLAPI aadlColAPI = new AADLCoLAPI();
		ProcessModelImpl vprocess = new ProcessModelImpl();
		
		ArrayList<ThreadSubcomponent> list2 = new ArrayList<ThreadSubcomponent>();
		for(int n = 0; n< list1.size(); n++){
			ProcessSubcomponent sub1 = list1.get(n); //sub process
    	  	ProcessImplementation p1_impl = (ProcessImplementation) sub1.getClassifier(); // process impl   	  	
    	  	ArrayList<ThreadSubcomponent> listx = aadlColAPI.Process_GetSubcomponentsThread(p1_impl);
    	  	if(listx.size()>0){
    	  		list2.addAll(listx);
    	  	}
		}
		
		vprocess = myLib.STree_mkSkeletonModel(myLib.mkIdentifier("Sim_Initialize") );
		
		//interface ============================================		
		//input: event top;
		org.eclipse.pop.ssme.Type type = myLib.mkPredefinedType(SignalOperators.opevent);
		SignalsDeclarationImpl vdecsig = myLib.STree_mkSignalDeclaration(myLib.mkIdentifier("top" ), type, null);
		myLib.STree_addDeclarationToInterface(vprocess, vdecsig, 2);
		
		//inputs: event dispach0, dispatch1, ...
		for(int i =0; i<list2.size(); i++){
			org.eclipse.pop.ssme.Type type1 = myLib.mkPredefinedType(SignalOperators.opevent);
			SignalsDeclarationImpl vdecsig1 = myLib.STree_mkSignalDeclaration(myLib.mkIdentifier("dispatch"+ Integer.toString(i) ), type1, null);
			myLib.STree_addDeclarationToInterface(vprocess, vdecsig1, 2);
		}
			
		//outputs: event init0, init1, ...;
		for(int j =0; j<list2.size(); j++){
			org.eclipse.pop.ssme.Type t1 = myLib.mkPredefinedType(SignalOperators.opevent);
			SignalsDeclarationImpl out1 = myLib.STree_mkSignalDeclaration(myLib.mkIdentifier("init"+ Integer.toString(j) ), t1, null);
			myLib.STree_addDeclarationToInterface(vprocess, out1, 3);
		}
		
		//body ===============================================
		//initx := ^0
		for(int j =0; j<list2.size(); j++){
			IdentifierImpl leftExp = myLib.mkIdentifier("init"+ Integer.toString(j) );
			NullClockImpl rightExp = new NullClockImpl();
			SignalsDefinitionImpl eq = (SignalsDefinitionImpl) myLib.mkEquation( leftExp, rightExp);
			myLib.STree_addExpressionOfProcessToaModel(vprocess, eq);
		}
		
//		//external
//		//external process
//		DescriptionImpl  desc = (DescriptionImpl) vprocess.getDescription();	
//	    if (desc == null)
//		{
//			  vprocess.setDescription(new DescriptionImpl());
//			  desc = (DescriptionImpl) vprocess.getDescription();
//		}
//	    ExternalAttributeImpl externe = new ExternalAttributeImpl();
//		desc.setBody(externe);
		
		//add comments for behavior process instance
		ArrayList<String> comments3 = new ArrayList<String>();
		comments3.add("Signal process simulates Initialize signals");
		comments3.add("Initialize at the first Dispatch");
		myLib.STree_addComment(vprocess, comments3, false);
		
		return vprocess;
		
	}
    
}
