 
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import java.util.ArrayList;
import org.osate.aadl2.*;

import org.eclipse.pop.ssme.impl.*;
import org.eclipse.pop.ssme.polychrony.SignalOperators;


 
public class ASME2SSME_Simulate_Resume  extends ASME2SSME_Simulate_Common {
	
	
	/**
	 * Class constructor
	 */
	public ASME2SSME_Simulate_Resume() {
	}
	
	
 
	
	/**
	 * Make a Signal process that simulates the generation of Resume signals
	 * 
	 * @param n
	 * @return
	 */
	public ProcessModelImpl ASME2SSME_mkSimResume(ProcessorSubcomponent subp, ArrayList<ProcessSubcomponent> list1){
		
//		process Sim_Resume = 
//			(? event top; event dispatch0, dispatch1, ...;
//			 ! event resume0, resume1, ...; )
//			(| resume0 := dispatch0
//           | resume1 := dispatch1
//           | ...
//			 |);
		
		Trace("\n ######## ASME2SSME_Simulate_Resume: ASME2SSME_mkSimResume : " + subp.getName());
		signalTreeAPI myLib= new signalTreeAPI();
    	AADLCoLAPI aadlColAPI = new AADLCoLAPI();
		ProcessModelImpl vprocess = new ProcessModelImpl();
		
		ArrayList<ThreadSubcomponent> list2 = new ArrayList<ThreadSubcomponent>();
		for(int n = 0; n< list1.size(); n++){
			ProcessSubcomponent sub1 = list1.get(n); //sub process
    	  	ProcessImplementation p1_impl = (ProcessImplementation) aadlColAPI.Processsubcomponent_GetClassifier(sub1); // process impl  	  	
    	  	ArrayList<ThreadSubcomponent> listx = aadlColAPI.Process_GetSubcomponentsThread(p1_impl);
    	  	if(listx.size()>0){
    	  		list2.addAll(listx);
    	  	}
		}
		
		vprocess = myLib.STree_mkSkeletonModel(myLib.mkIdentifier("Sim_Resume") );
		
		//interface ============================================		
		//input: event top;
		org.eclipse.pop.ssme.Type type = myLib.mkPredefinedType(SignalOperators.opevent);
		SignalsDeclarationImpl vdecsig = myLib.STree_mkSignalDeclaration(myLib.mkIdentifier("top" ), type, null);
		myLib.STree_addDeclarationToInterface(vprocess, vdecsig, 2);
		
		//inputs: event dispach0, dispatch1, ...
		for(int i =0; i<list2.size(); i++){
			org.eclipse.pop.ssme.Type type1 = myLib.mkPredefinedType(SignalOperators.opevent);
			SignalsDeclarationImpl vdecsig1 = myLib.STree_mkSignalDeclaration(myLib.mkIdentifier("dispatch"+ Integer.toString(i) ), type1, null);
			myLib.STree_addDeclarationToInterface(vprocess, vdecsig1, 2);
		}
			
		//outputs: event resume0, resume1, ...;
		for(int j =0; j<list2.size(); j++){
			org.eclipse.pop.ssme.Type t1 = myLib.mkPredefinedType(SignalOperators.opevent);
			SignalsDeclarationImpl out1 = myLib.STree_mkSignalDeclaration(myLib.mkIdentifier("resume"+ Integer.toString(j) ), t1, null);
			myLib.STree_addDeclarationToInterface(vprocess, out1, 3);
		}
		
		//body ===============================================
		// resumex := dispatchx
		for(int k =0; k<list2.size(); k++){
			IdentifierImpl leftExp = myLib.mkIdentifier("resume"+ Integer.toString(k) );
			IdentifierImpl rightExp = myLib.mkIdentifier("dispatch"+ Integer.toString(k) );
			SignalsDefinitionImpl eq = (SignalsDefinitionImpl) myLib.mkEquation( leftExp, rightExp);
			myLib.STree_addExpressionOfProcessToaModel(vprocess, eq);
		}
		
		//add comments for behavior process instance
		ArrayList<String> comments3 = new ArrayList<String>();
		comments3.add("Signal process simulates Resume signals");
		myLib.STree_addComment(vprocess, comments3, false);
		
		return vprocess;
		
	}
    
}
