
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import org.osate.aadl2.*;

public class ASME2SSME_Translate_Connection extends ASME2SSME_Translate_Mode{

	private AADLCoLAPI aadlColAPI;  
	/**
	 * Class constructor
	 */
	public ASME2SSME_Translate_Connection() { 
		aadlColAPI = new AADLCoLAPI();
	}


	/**
	 * Translate bus access connection
	 * @param c1
	 */
	public void ASME2SSME_BusAccessConnection(AccessConnection c1){
		Trace("\n ######## ASME2SSME_Translate_Connection: ASME2SSME_BusAccessConnection "+ c1.getName());

		if (aadlColAPI.AccessConnection_GetCategory(c1) == "bus"){
			Trace("BusAccessConnection not yet implemented");
		}

	}


	/**
	 * Translate data access connection
	 * @param c1
	 */
	public void ASME2SSME_DataAccessConnection(AccessConnection c1){
		Trace("\n ######## ASME2SSME_Translate_Connection: ASME2SSME_DataAccessConnection "+ c1.getName());

		if(aadlColAPI.AccessConnection_GetCategory(c1) == "data"){
			Trace("DataAccessConnection not yet implemented");
		}
	}


	/**
	 * Translate feature connection
	 * 
	 */
	public void ASME2SSME_FeatureConnection(){

		Trace("\n ######## ASME2SSME_Translate_Connection: ASME2SSME_FeatureConnection ");
		Trace("FeatureConnection not yet implemented");
	}


	/**
	 * Translate feature group connection
	 * 
	 */
	public void ASME2SSME_FeatureGroupConnection(){

		Trace("\n ######## ASME2SSME_Translate_Connection: ASME2SSME_FeatureGroupConnection ");
		Trace("FeatureGroupConnection not yet implemented");
	}


	/**
	 * Print out the information of a data port connection
	 * 
	 * @param dataConnection a data port connection
	 */
	public void read_DataConnection(PortConnection dataConnection){

		Trace("\n ######## ASME2SSME_Translate_Connection: read_DataConnection ");
		Trace("------Connection name: " + dataConnection.getName());
		Trace("---------Source:" + dataConnection.getAllSource().getName() + " of " + dataConnection.getAllSourceContext().getName());
		Trace("---------Destination:" + dataConnection.getAllDestination().getName() + " of " + dataConnection.getAllDestinationContext().getName());
	}


	/**
	 * Print out the information of a event port connection
	 * 
	 * @param eventConnection an event port connection
	 */
	public void read_EventConnection(PortConnection eventConnection){

		Trace("\n ######## ASME2SSME_Translate_Connection: read_EventConnection ");
		Trace("------Connection name:" + eventConnection.getName());
		Trace("---------Source:" + eventConnection.getAllSource().getName() + " of " + eventConnection.getAllSourceContext().getName());
		Trace("---------Destination:" + eventConnection.getAllDestination().getName() + " of " + eventConnection.getAllSourceContext().getName());
	}

}
