 
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import org.osate.aadl2.*;
import org.eclipse.pop.ssme.*;
import org.eclipse.pop.ssme.impl.*;


public class ASME2SSME_Translate_PortGroup extends ASME2SSME_Translate_Feature{
	// private AADLCoLAPI aadlColAPI;
	private signalTreeAPI myLib;

	private SignalsDeclarationImpl PortGroup(FeatureGroupType pgt, String pg_sig_name, String vstring) {
		String pgt_sig_name = Name_of_PortGroupType(pgt.getName(), vstring);
		Identifier type = myLib.mkIdentifier(pgt_sig_name); 
		IdentifierImpl id = myLib.mkIdentifier(pg_sig_name);
		return  myLib.STree_mkSignalDeclaration(id, type, null);			
	}
	
	/**
	 * Class constructor
	 */
	public ASME2SSME_Translate_PortGroup() {
		// aadlColAPI = new AADLCoLAPI();
		myLib= new signalTreeAPI();
	}

	/**
	 * Translates port group (feature group in OSATE2). 
	 * The in ports are translated to a Signal bundle xx_BW
	 * 
	 * @param pg a port group
	 */
	private TypesDeclarationImpl ASME2SSME_PortGroupType_BW(FeatureGroupType pgt){

		Trace("\n == ASME2SSME_Trasnalte_PortGroup: ASME2SSME_PortGroupType_BW " + pgt.getName());

		TypesDeclarationImpl type_decl = new TypesDeclarationImpl();
		// TypeDescriptionImpl typedescr = new TypeDescriptionImpl();	
		// ExprSignal vinit = null;	

		String pgt_name = pgt.getName();
		// String pgt_sig_name = Name_of_PortGroupType(pgt_name, "BW"	);
		// Identifier id = myLib.mkIdentifier(pgt_sig_name);

		//		    EList fea_list = pgt.getFeature();    
		//		    PortGroupType inverse = pgt.getInverseOf();
		//		    
		//		    if (fea_list.size() == 0){
		//		    
		//		       if (inverse == null){
		//		    	    type_decl.getTypeDefinition().add(id);
		//		    	    //Trace("inverse == null");
		//		       }
		//		       else{ //inverse of some other port group: type xx_In = inverse_Out
		//		    	   
		//		    	   if(ASME2SSME_PortGroupType_WB(inverse) == null){
		//		    		   return null;
		//		    	   }
		//		    	   else{
		//		    		   String inverse_name = inverse.getName();
		//			    	   String inverse_sig_str = Name_of_PortGroupType(inverse_name, "WB");
		//		    		   Identifier inverse_id = myLib.mkIdentifier(inverse_sig_str);
		//					   typedescr = myLib.STree_mkDclType(id, inverse_id, vinit);
		//					   type_decl.getTypeDefinition().add(typedescr);
		//		    	   }
		//		       }		    				    
		//		    }
		//		    else {//features: in out ports
		//			    TupleTypeImpl description = new TupleTypeImpl();
		//			    description.setTypeKind(TypeKind.BUNDLE_LITERAL);
		//						    
		//			    if(fea_list.size()>0){
		//			    	
		//			    	int cnt =0;
		//			    	for(int i =0; i< fea_list.size(); i++){		    		
		//			    		//in data port
		//			    		if(fea_list.get(i) instanceof DataPort){
		//						    DataPort p1 = (DataPort) fea_list.get(i);
		//						    if(p1.getDirection().toString()  == "in"){
		//						    	SignalsDeclarationImpl decl1 = ASME2SSME_DataPort(p1);
		//							    description.getListSignalsDeclaration().add(decl1);
		//							    cnt++;
		//						    }						    
		//			    		}
		//			    		//in event port
		//			    		else if(fea_list.get(i) instanceof EventPort){
		//			    			EventPort p2 = (EventPort) fea_list.get(i);
		//						    if(p2.getDirection().toString()  == "in"){
		//						    	SignalsDeclarationImpl decl2 = ASME2SSME_EventPort(p2);
		//							    description.getListSignalsDeclaration().add(decl2);
		//							    cnt++;
		//						    }	
		//			    		}
		//			    		//in event data port
		//			    		else if(fea_list.get(i) instanceof EventDataPort){
		//			    			EventDataPort p3 = (EventDataPort) fea_list.get(i);
		//						    if(p3.getDirection().toString()  == "in"){
		//						    	SignalsDeclarationImpl decl3 = ASME2SSME_EventDataPort(p3);
		//							    description.getListSignalsDeclaration().add(decl3);
		//							    cnt++;
		//						    }	
		//			    		}
		//			    		else{
		//			    			Trace("\n port group of group not yet implemented");
		//			    		}
		//			    	} // end for
		//			    	
		//			        if(cnt == 0){
		//			        	//type_decl.getTypeDefinition().add(id);	
		//			        	return null;
		//			    	}
		//			    	else{
		//			    		typedescr = myLib.STree_mkDclType(id, description, vinit);
		//					    type_decl.getTypeDefinition().add(typedescr);
		//			    	}
		//			    	
		//			    }			    
		//		    }


		myLib.STree_addComment(type_decl, "port group type for " + pgt_name, false);
		return type_decl;
	}

	/**
	 * Translates port group.
	 * The out ports are translated to a Signal bundle xx_WB
	 * 
	 * @param pg a port group
	 */
	private TypesDeclarationImpl ASME2SSME_PortGroupType_WB(FeatureGroupType pgt){

		Trace("\n == ASME2SSME_Trasnalte_PortGroup: ASME2SSME_PortGroupType_WB " + pgt.getName());

		TypesDeclarationImpl type_decl = new TypesDeclarationImpl();
		//		TypeDescriptionImpl typedescr = new TypeDescriptionImpl();	
		//		ExprSignal vinit = null;	

		String pg_name = pgt.getName();
		// 	String pg_sig_name = Name_of_PortGroupType(pg_name, "WB");
		//		Identifier id = myLib.mkIdentifier(pg_sig_name);

		//		    EList fea_list = pgt.getFeature();
		//		    PortGroupType inverse = pgt.getInverseOf();
		//		    
		//		    if (fea_list.size() == 0 ){
		//		    
		//		       if (inverse == null){
		//		    	   type_decl.getTypeDefinition().add(id);	
		//		       }
		//		       else{//inverse of some other port group: type xx_Out = inverse_In
		//		    	   if(ASME2SSME_PortGroupType_BW(inverse) == null){
		//		    		   return null;
		//		    	   }
		//		    	   else{
		//		    		   String inverse_name = inverse.getName();
		//			    	   Identifier inverse_id = myLib.mkIdentifier(Name_of_PortGroupType(inverse_name, "BW"));
		//					   typedescr = myLib.STree_mkDclType(id, inverse_id, vinit);
		//					   type_decl.getTypeDefinition().add(typedescr);
		//		    	   }		    	   
		//		       }		    
		//		    }
		//		    else {//features: in out ports
		//			    TupleTypeImpl description = new TupleTypeImpl();
		//			    description.setTypeKind(TypeKind.BUNDLE_LITERAL);
		//						    
		//			    if(fea_list.size()>0){
		//			    	int cnt =0;
		//			    	for(int i =0; i< fea_list.size(); i++){
		//			    		
		//			    		//out data port
		//			    		if(fea_list.get(i) instanceof DataPort){
		//						    DataPort p1 = (DataPort) fea_list.get(i);
		//						    if(p1.getDirection().toString()  == "out"){
		//						    	SignalsDeclarationImpl decl1 = ASME2SSME_DataPort(p1);
		//							    description.getListSignalsDeclaration().add(decl1);
		//							    cnt++;
		//						    }						    
		//			    		}
		//			    		//out event port
		//			    		else if(fea_list.get(i) instanceof EventPort){
		//			    			EventPort p2 = (EventPort) fea_list.get(i);
		//						    if(p2.getDirection().toString()  == "out"){
		//						    	SignalsDeclarationImpl decl2 = ASME2SSME_EventPort(p2);
		//							    description.getListSignalsDeclaration().add(decl2);
		//							    cnt++;
		//						    }	
		//			    		}
		//			    		//out event data port
		//			    		else if(fea_list.get(i) instanceof EventDataPort){
		//			    			EventDataPort p3 = (EventDataPort) fea_list.get(i);
		//						    if(p3.getDirection().toString()  == "out"){
		//						    	SignalsDeclarationImpl decl3 = ASME2SSME_EventDataPort(p3);
		//							    description.getListSignalsDeclaration().add(decl3);
		//							    cnt++;
		//						    }	
		//			    		}
		//			    		else{
		//			    			Trace("\n port group of group not yet implemented");
		//			    		}
		//			    	}//end for
		//			    	
		//			    	if(cnt ==0){
		//			    		return null;
		//			    	}
		//			    	else{
		//			    		typedescr = myLib.STree_mkDclType(id, description, vinit);
		//					    type_decl.getTypeDefinition().add(typedescr);
		//			    	}
		//			    }			    		    
		//		    }

		myLib.STree_addComment(type_decl, "port group type for " + pg_name, false);
		return type_decl;
	}


	/**
	 * Translates port group (feature group in OSATE2). 
	 * A port group is seperated into a pair of signals: xx_bw and xx_wb. 
	 * This method returns a signal declaration for xx_bw
	 * 
	 * @param pg a port group
	 */
	public SignalsDeclarationImpl ASME2SSME_PortGroup_bw(FeatureGroup pg){

		String pg_name = pg.getName();
		Trace("\n == ASME2SSME_Trasnalte_PortGroup: ASME2SSME_PortGroup_bw " + pg_name);
		FeatureGroupType pgt = pg.getFeatureGroupType();
		if (ASME2SSME_PortGroupType_BW(pgt) == null) return null;
		String pg_sig_name = Name_of_PortGroup(pg_name, "bw");
		return PortGroup(pgt, pg_sig_name, "BW");
	}


	/**
	 * Translates port group (feature group in OSATE2). 
	 * A port group is seperated into two signals: an in bundle and an out bundle. 
	 * This method returns a signal declaration for the out bundle
	 * 
	 * @param pg a port group
	 */
	public SignalsDeclarationImpl ASME2SSME_PortGroup_wb(FeatureGroup pg){

		String pg_name = pg.getName();
		Trace("\n == ASME2SSME_Trasnalte_PortGroup: ASME2SSME_PortGroup_wb " + pg_name);
		FeatureGroupType pgt = pg.getFeatureGroupType();
		if (ASME2SSME_PortGroupType_WB(pgt) == null) return null;		 
		String pg_sig_name = Name_of_PortGroup(pg_name, "wb");
		return PortGroup(pgt, pg_sig_name, "WB" );
		 
	}

	

}
