 
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import org.osate.aadl2.*;
import org.eclipse.pop.ssme.impl.*;

public class ASME2SSME_Translate_PortGroupConnection extends ASME2SSME_Translate_Connection{

	//---LBesnard:  This class is not yet referenced.

	/**
	 * Class constructor
	 */
	public ASME2SSME_Translate_PortGroupConnection() {

	}


	/** 
	 * Returns a Signal signal definition (an equation) that represents a port group connection. 
	 * A port group connection is separated into two direction connections: 
	 * 1) from source port group's out ports to dst port group's in ports
	 * 2) from dst port group's out ports to source port group's in ports
	 * This method im[lements the first case: src_BUNDLEOut -> dst_BUNDLEIn
	 * <p>
	 * Depending on the source and dst context of the connection, different connection is provided. 
	 * 
	 * @param compImpl a component implementation component
	 * @param vprocess a Signal process that represents an AADL component which contains this connection
	 * @param dconnection a data port connection
	 * @return a signal definition (an equation)
	 */
	public SignalsDefinitionImpl _ASME2SSME_PortGroupConnection1(FeatureGroupConnection c1){

		Trace("\n ######## ASME2SSME_Translate_Connection: ASME2SSME_PortGroupConnection1 "+ c1.getName());

		//		signalTreeAPI myLib= new signalTreeAPI();
		//		AADLCoLAPI aadlColAPI = new AADLCoLAPI();
		//		ASME2SSME_Translate_Common asme2ssme_common = new ASME2SSME_Translate_Common();	
		SignalsDefinitionImpl eq = new SignalsDefinitionImpl();

		//			PortGroup src = c1.getSrc();
		//			PortGroup dst = c1.getDst();
		//			
		//			PortGroupType pgt = src.getPortGroupType();
		//			ASME2SSME_Translate_PortGroup asme2ssme_pgt = new ASME2SSME_Translate_PortGroup();
		//			if(asme2ssme_pgt.ASME2SSME_PortGroupType_WB(pgt) == null){
		//					Trace("Port group connection from wb bundle direction not exist ");
		//					return null;
		//			}
		//			else{
		//				
		//				FeatureContext src_context = c1.getSrcContext();
		//				FeatureContext dst_context = c1.getDstContext();
		//				String left_name;
		//				String right_name;
		//				
		//				//systemImpl.PortGroup -> ========================================
		//				if(src_context instanceof SystemImpl){
		//					
		//					right_name = Name_of_PortGroup(src.getName(), "WB");
		//					ExprSignal right_expr = myLib.mkIdentifier(right_name);
		//					
		//					//systemImpl.PortGroup -> Subsystem.PortGroup | Subprocess.PortGroup | SubDevice.PortGroup
		//					if(dst_context instanceof SystemSubcomponent
		//							| dst_context instanceof ProcessSubcomponent
		//							| dst_context instanceof DeviceSubcomponent){
		//						
		//						if (dst_context instanceof SystemSubcomponent){
		//							SystemSubcomponent dst_sub = (SystemSubcomponent) dst_context;
		//							left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						}
		//						else if (dst_context instanceof ProcessSubcomponent){
		//							ProcessSubcomponent dst_sub = (ProcessSubcomponent) dst_context;
		//							left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						}
		//						else {
		//							DeviceSubcomponent dst_sub = (DeviceSubcomponent) dst_context;
		//							left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						}
		//
		//						String sn1 = getSname(left_name);
		//					    ExprSignal left_expr = myLib.mkIdentifier(sn1);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//					}
		//					else{
		//						Trace("Port group connection from a system (some case) not yet implemented ");
		//						return null;
		//					}
		//				}
		//				
		//				//processImpl.PortGroup -> =======================================
		//				else if(src_context instanceof ProcessImplementation) {
		//							
		//					right_name = Name_of_PortGroup(src.getName(), "wb");
		//					ExprSignal right_expr = myLib.mkIdentifier(right_name);
		//					
		//					 //processImpl.PortGroup ->Subthread.PortGroup
		//					if (dst_context instanceof ThreadSubcomponent){
		//								
		//						ThreadSubcomponent dst_sub = (ThreadSubcomponent) dst_context;
		//						left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						String sn1 = getSname(left_name);
		//					    ExprSignal left_expr = myLib.mkIdentifier(sn1);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//						}
		//					else{
		//						Trace("Port group connection from a process some case not yet implemented ");
		//						return null;
		//						}
		//					}
		//				
		//				//Subsystem.PortGroup | Subprocess.PortGroup | Subdevice.PortGroup -> ==========================================
		//				else if (src_context instanceof SystemSubcomponent
		//						| src_context instanceof ProcessSubcomponent
		//						| src_context instanceof DeviceSubcomponent){
		//					
		//					if (src_context instanceof SystemSubcomponent){
		//						SystemSubcomponent src_sub = (SystemSubcomponent) src_context;
		//						right_name =  src_sub.getName() + "_" + Name_of_PortGroup(src.getName(), "wb");
		//					}
		//					else if (src_context instanceof ProcessSubcomponent){
		//						ProcessSubcomponent src_sub = (ProcessSubcomponent) src_context;
		//						right_name =  src_sub.getName() + "_" + Name_of_PortGroup(src.getName(), "wb");
		//					}
		//					else {
		//						DeviceSubcomponent src_sub = (DeviceSubcomponent) src_context;
		//						right_name =  src_sub.getName() + "_" + Name_of_PortGroup(src.getName(), "wb");
		//					}
		//								
		//					String sn1 = getSname(right_name);
		//				    ExprSignal right_expr = myLib.mkIdentifier(sn1);
		//				    
		//				    //Subsystem.PortGroup | ... -> system.PortGroup 
		//				    if(dst_context instanceof SystemImplementation){
		//				    	
		//				    	left_name = Name_of_PortGroup(dst.getName(), "bw");
		//				    	ExprSignal left_expr = myLib.mkIdentifier(left_name);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//				    }
		//				    
		//				    //Subsystem.PortGroup | ... -> Subsystem.PortGroup | Subprocess.PortGroup | Subdevice.PortGroup
		//				    else if(dst_context instanceof SystemSubcomponent
		//				    		| dst_context instanceof ProcessSubcomponent
		//				    		| dst_context instanceof DeviceSubcomponent){
		//				    	
		//				    	if (dst_context instanceof SystemSubcomponent){
		//							SystemSubcomponent dst_sub = (SystemSubcomponent) dst_context;
		//							left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						}
		//						else if (dst_context instanceof ProcessSubcomponent){
		//							ProcessSubcomponent dst_sub = (ProcessSubcomponent) dst_context;
		//							left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						}
		//						else {
		//							DeviceSubcomponent dst_sub = (DeviceSubcomponent) dst_context;
		//							left_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						}
		//
		//						String sn2 = getSname(left_name);
		//					    ExprSignal left_expr = myLib.mkIdentifier(sn2);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//				    }
		//				    
		//				    else{
		//				    	Trace("Port group connection not yet implemented ");
		//						return null;
		//				    }
		//				    
		//				}
		//				
		//				else{
		//					Trace("Port group connection not yet implemented ");
		//					return null;
		//					}
		//			}

		return eq;

	}


	/** 
	 * Returns a Signal signal definition (an equation) that represents a port group connection. 
	 * A port group connection is separated into two direction connections: 
	 * 1) from source port group's out ports to dst port group's in ports
	 * 2) from dst port group's out ports to source port group's in ports
	 * This method im[lements the second case: dst_BUNDLEOut -> src_BUNDLEIn
	 * <p>
	 * Depending on the source and dst context of the connection, different connection is provided. 
	 * 
	 * @param compImpl a component implementation component
	 * @param vprocess a Signal process that represents an AADL component which contains this connection
	 * @param dconnection a data port connection
	 * @return a signal definition (an equation)
	 */
	public SignalsDefinitionImpl _ASME2SSME_PortGroupConnection2(FeatureGroupConnection c1){

		Trace("\n ######## ASME2SSME_Translate_Connection: ASME2SSME_PortGroupConnection2 "+ c1.getName());

		//		signalTreeAPI myLib= new signalTreeAPI();
		//		AADLCoLAPI aadlColAPI = new AADLCoLAPI();
		//		ASME2SSME_Translate_Common asme2ssme_common = new ASME2SSME_Translate_Common();	
		SignalsDefinitionImpl eq = new SignalsDefinitionImpl();
		//		ASME2SSME_Translate_PortGroup asme2ssme_pgt = new ASME2SSME_Translate_PortGroup();

		//			PortGroup src = c1.getSrc();
		//			PortGroup dst = c1.getDst();
		//			
		//			PortGroupType pgt = src.getPortGroupType();
		//			if(asme2ssme_pgt.ASME2SSME_PortGroupType_BW(pgt) == null){
		//					Trace("Port group connection from bw bundle direction not exist ");
		//					return null;
		//			}
		//			else{
		//				
		//				FeatureContext src_context = c1.getSrcContext();
		//				FeatureContext dst_context = c1.getDstContext();
		//				String left_name;
		//				String right_name;
		//				
		//				//systemImpl.PortGroup -> ========================================
		//				if(src_context instanceof SystemImplementation){
		//					
		//					left_name = Name_of_PortGroup(src.getName(), "bw");
		//					ExprSignal left_expr = myLib.mkIdentifier(left_name);
		//					
		//					//systemImpl.PortGroup -> Subsystem.PortGroup | Subprocess.PortGroup | SubDevice.PortGroup
		//					if(dst_context instanceof SystemSubcomponent
		//							| dst_context instanceof ProcessSubcomponent
		//							| dst_context instanceof DeviceSubcomponent){
		//						
		//						if (dst_context instanceof SystemSubcomponent){
		//							SystemSubcomponent dst_sub = (SystemSubcomponent) dst_context;
		//							right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "wb");
		//						}
		//						else if (dst_context instanceof ProcessSubcomponent){
		//							ProcessSubcomponent dst_sub = (ProcessSubcomponent) dst_context;
		//							right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "wb");
		//						}
		//						else {
		//							DeviceSubcomponent dst_sub = (DeviceSubcomponent) dst_context;
		//							right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "wb");
		//						}
		//
		//						String sn1 = getSname(right_name);
		//					    ExprSignal right_expr = myLib.mkIdentifier(sn1);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//					}
		//					else{
		//						Trace("Port group connection from a system (some case) not yet implemented ");
		//						return null;
		//					}
		//				}
		//				
		//				//processImpl.PortGroup -> =======================================
		//				else if(src_context instanceof ProcessImplementation) {
		//							
		//					left_name = Name_of_PortGroup(src.getName(), "bw");
		//					ExprSignal left_expr = myLib.mkIdentifier(left_name);
		//					
		//					 //processImpl.PortGroup ->Subthread.PortGroup
		//					if (dst_context instanceof ThreadSubcomponent){
		//								
		//						ThreadSubcomponent dst_sub = (ThreadSubcomponent) dst_context;
		//						right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "bw");
		//						String sn1 = getSname(right_name);
		//					    ExprSignal right_expr = myLib.mkIdentifier(sn1);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//						}
		//					else{
		//						Trace("Port group connection from a process some case not yet implemented ");
		//						return null;
		//						}
		//					}
		//				
		//				//Subsystem.PortGroup | Subprocess.PortGroup | Subdevice.PortGroup -> ==========================================
		//				else if (src_context instanceof SystemSubcomponent
		//						| src_context instanceof ProcessSubcomponent
		//						| src_context instanceof DeviceSubcomponent){
		//					
		//					if (src_context instanceof SystemSubcomponent){
		//						SystemSubcomponent src_sub = (SystemSubcomponent) src_context;
		//						left_name =  src_sub.getName() + "_" + Name_of_PortGroup(src.getName(), "bw");
		//					}
		//					else if (src_context instanceof ProcessSubcomponent){
		//						ProcessSubcomponent src_sub = (ProcessSubcomponent) src_context;
		//						left_name =  src_sub.getName() + "_" + Name_of_PortGroup(src.getName(), "bw");
		//					}
		//					else {
		//						DeviceSubcomponent src_sub = (DeviceSubcomponent) src_context;
		//						left_name =  src_sub.getName() + "_" + Name_of_PortGroup(src.getName(), "bw");
		//					}
		//								
		//					String sn1 = getSname(left_name);
		//				    ExprSignal left_expr = myLib.mkIdentifier(sn1);
		//				    
		//				    //Subsystem.PortGroup | ... -> system.PortGroup 
		//				    if(dst_context instanceof SystemImplementation){
		//				    	
		//				    	right_name = Name_of_PortGroup(dst.getName(), "wb");
		//				    	ExprSignal right_expr = myLib.mkIdentifier(right_name);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//				    }
		//				    
		//				    //Subsystem.PortGroup | ... -> Subsystem.PortGroup | Subprocess.PortGroup | Subdevice.PortGroup
		//				    else if(dst_context instanceof SystemSubcomponent
		//				    		| dst_context instanceof ProcessSubcomponent
		//				    		| dst_context instanceof DeviceSubcomponent){
		//				    	
		//				    	if (dst_context instanceof SystemSubcomponent){
		//							SystemSubcomponent dst_sub = (SystemSubcomponent) dst_context;
		//							right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "wb");
		//						}
		//						else if (dst_context instanceof ProcessSubcomponent){
		//							ProcessSubcomponent dst_sub = (ProcessSubcomponent) dst_context;
		//							right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "wb");
		//						}
		//						else {
		//							DeviceSubcomponent dst_sub = (DeviceSubcomponent) dst_context;
		//							right_name =  dst_sub.getName() + "_" + Name_of_PortGroup(dst.getName(), "wb");
		//						}
		//
		//						String sn2 = getSname(right_name);
		//					    ExprSignal right_expr = myLib.mkIdentifier(sn2);
		//						eq = (SignalsDefinitionImpl) myLib.mkEquation( left_expr, right_expr);
		//				    }
		//				    
		//				    else{
		//				    	Trace("Port group connection not yet implemented ");
		//						return null;
		//				    }
		//				    
		//				}
		//				
		//				else{
		//					Trace("Port group connection not yet implemented ");
		//					return null;
		//					}
		//			}

		return eq;
	}


}
