 
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import java.util.ArrayList;
import java.util.Iterator;

import org.osate.aadl2.*;
import org.eclipse.pop.ssme.*;
import org.eclipse.pop.ssme.impl.*;
 
public class ASME2SSME_Translate_Property extends ASME2SSME_Translate_Name{
	public static final String ACTUAL_CONNECTION_BINDING_ID = "Actual_Connection_Binding";
	public static final String ACTUAL_CONNECTION_BINDING_PROPERTY_ID = "Actual_Connection_Binding_property";
	public static final String ACTUAL_PROCESSOR_BINDING_ID = "Actual_Processor_Binding";
	public static final String ACTUAL_PROCESSOR_BINDING_PROPERTY_ID = "Actual_Processor_Binding_property";
	public static final String CLOCK_PERIOD_ID = "Clock_Period" ;
	public static final String CLOCK_PERIOD_PROPERTY_ID = "Clock_Period_property";
	public static final String DEADLINE_PROPERTY_ID = "Deadline_property";
	public static final String DEQUEUED_ITEMS_ID = "Dequeued_Items";
	public static final String DEQUEUED_ITEMS_PROPERTY_ID = "Dequeued_Items_property";  
	public static final String DEQUEUE_PROTOCOL_ID = "Dequeue_Protocol";
	public static final String DEQUEUE_PROTOCOL_PROPERTY_ID = "Dequeue_Protocol_property";
	public static final String DEVICE_DISPATCH_PROTOCOL_ID = "Device_Dispatch_Protocol";
	public static final String DISPATCH_PROTOCOL_ID = "Dispatch_Protocol";
	public static final String DISPATCH_PROTOCOL_PROPERTY =  "Dispatch_Protocol_property";
	public static final String FAN_OUT_POLICY_ID = "Fan_Out_Policy";
	public static final String FLOWLATENCY_PROPERTY_ID = "FlowLatency_property";
	public static final String FROZEN_TIME_EVENT_ID = "Frozen_Time_event";
	public static final String INPUT_TIME_PROPERTY_ID = "Input_Time_property";
	public static final String INPUT_TIME_REFERENCE_TIME_ID = "Input_Time_Reference_Time" ;
	public static final String INPUT_TIME_REFERENCE_TIME_PROPERTY_ID = "Input_Time_Reference_Time_property";
	public static final String LATENCY_PROPERTY_ID = "Latency_property";
	public static final String LATENCY_TIME_EVENT_ID = "Latency_Time_event";
	public static final String OUTPUT_TIME_EVENT_ID = "Output_Time_event";
	public static final String OUTPUT_TIME_PROPERTY_ID = "Output_Time_property";
	public static final String OUTPUT_TIME_REFERENCE_TIME_ID = "Output_Time_Reference_Time" ;
	public static final String OUTPUT_TIME_REFERENCE_TIME_PROPERTY_ID = "Output_Time_Reference_Time_property";
	public static final String OVERFLOW_HANDLING_PROTOCOL_ID = "Overflow_Handling_Protocol" ;
	public static final String OVERFLOW_HANDLING_PROTOCOL_PROPERTY_ID = "Overflow_Handling_Protocol_property";
	public static final String PERIOD_ID = "Period";
	public static final String PERIOD_PROPERTY = "Period_property";
	public static final String PRIORITY_ID = "Priority" ;
	public static final String QUEUE_PROCESSING_PROTOCOL_ID = "Queue_Processing_Protocol";
	public static final String QUEUE_PROCESSING_PROTOCOL_PROPERTY_ID = "Queue_Processing_Protocol_property";
	public static final String QUEUE_SIZE_ID = "Queue_Size";
	public static final String QUEUE_SIZE_PROPERTY_ID = "Queue_Size_property";
	public static final String READ_TIME_ID = "Read_Time" ;
	public static final String READ_TIME_PROPERTY_ID = "Read_Time_property";
	public static final String REFERENCE_TIME_EVENT_ID = "Reference_Time_event";
	public static final String SUPPORTED_DISPATCH_PROTOCOLS = "Supported_Dispatch_Protocols";
	public static final String TIME_OFFSET_ID = "Time_Offset" ;
	public static final String TIME_OFFSET_PROPERTY_ID = "Time_Offset_property";
	public static final String TIME_UNITS_ID = "Time_Units";
	public static final String TIMING_ID = "Timing";
	public static final String TIMING_PROPERTY_ID = "Timing_property";
	private static final String LATENCY_ID = "Latency";
	private static final String ACTUAL_LATENCY_ID = "Actual_Latency";
  
	
	private AADLCoLAPI aadlColAPI;
	private signalTreeAPI myLib;
	
	
	private ProcessCallImpl	mkSignalProperty(String PropertyName , ArrayList<ExprParam> lparams, ArrayList<ExprSignal> linputs)
	{
		return myLib.STree_mkCompleteProcessCall(myLib.mkIdentifier(PropertyName), lparams, linputs);
	}

	private ProcessCallImpl	mkSignalProperty(String PropertyName, ExprParam vp)
	{
		ArrayList<ExprParam> lparams = new ArrayList<ExprParam>();
		lparams.add(vp);
		return mkSignalProperty(PropertyName, lparams, new ArrayList<ExprSignal>());
	}

	private ProcessCallImpl	 mkSignalProperty(String PropertyName , ConstantEnumImpl v)
	{
		return mkSignalProperty(PropertyName, (ExprParam) v);
	}

	private ProcessCallImpl	 mkSignalProperty(String PropertyName , ConstantIntegerImpl v)
	{
		return mkSignalProperty(PropertyName, (ExprParam) v);
	}

	private ProcessCallImpl	 mkSignalProperty(String PropertyName , ConstantRealImpl v)
	{
		return mkSignalProperty(PropertyName, (ExprParam) v);		
	}
	
	/** 
	 * @return the list of parameters composed of a time unit (VTimeUnit) and a real value ( RealValue).
	 * */
	private ArrayList<ExprParam> mkPeriodUnitParameters(String vTimeUnit , String  RealValue) {
		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		lparam.add(ASME2SSME_Time_Unit_ConstantEnum(vTimeUnit));
		lparam.add(myLib.STree_mkRealConstant(RealValue));
		return lparam;
	}
	
	private PropertyAssociation getPortPropertyAssociation(Port p, String PropertyName) {

		ArrayList<PropertyAssociation> p_list1 = aadlColAPI.Port_Get_PropertyAssociation(p);
		if(p_list1.size()>0)
		{
			Iterator<PropertyAssociation> it1 = p_list1.iterator();
			while (it1.hasNext())
			{
				PropertyAssociation pa = (PropertyAssociation) it1.next();
				String propertyDef_name = aadlColAPI.Property_Get_Name(pa);  			
				if (propertyDef_name.equals(PropertyName)) return pa;
			}
		}
		return null;
	}
	
	
	private ProcessCallImpl genLatencyProperty(PropertyAssociation pa, String flow_name, String vPropName) {
		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		
		String propertyDef_name = aadlColAPI.Property_Get_Name(pa);
		if (! propertyDef_name.equals(vPropName)) return null;
		
		StringValueImpl cr0 = myLib.STree_mkStringValue(flow_name);		
		lparam.add(cr0);
		ArrayList<ModalPropertyValue> listPropertyValue = aadlColAPI.Property_Get_Values(pa);   	
		for (int j = 0; j < listPropertyValue.size(); j++) {  
			ModalPropertyValue mpv = listPropertyValue.get(j);
			if (aadlColAPI.ModalPropertyValue_Get_Value(mpv) instanceof RangeValue) 
			{
				RangeValue propertyValue = (RangeValue) aadlColAPI.ModalPropertyValue_Get_Value(mpv);

				String min_v = aadlColAPI.IntegerLiteralRange_Get_MinValue(propertyValue);
				ConstantRealImpl cr1 = myLib.STree_mkRealConstant(min_v);			
				lparam.add(cr1);   

				String min_u = aadlColAPI.IntegerLiteralRange_Get_MinUnit(propertyValue);
				ConstantEnumImpl unit1 = ASME2SSME_Time_Unit_ConstantEnum(min_u);
				lparam.add(unit1);

				String max_v =aadlColAPI.IntegerLiteralRange_Get_MaxValue(propertyValue);
				ConstantRealImpl cr2 = myLib.STree_mkRealConstant(max_v);			
				lparam.add(cr2);   

				String max_u = aadlColAPI.IntegerLiteralRange_Get_MaxUnit(propertyValue);
				ConstantEnumImpl unit2 = ASME2SSME_Time_Unit_ConstantEnum(max_u);
				lparam.add(unit2);
			}
			else if (aadlColAPI.ModalPropertyValue_Get_Value(mpv) instanceof IntegerLiteral) {
				IntegerLiteral value1 = (IntegerLiteral) aadlColAPI.ModalPropertyValue_Get_Value(mpv);

				String min_v = aadlColAPI.IntegerLiteral_Get_Value(value1);
				ConstantRealImpl cr1 = myLib.STree_mkRealConstant(min_v);			
				lparam.add(cr1);   

				String min_u = aadlColAPI.IntegerLiteral_Get_Unit(value1);
				ConstantEnumImpl unit1 = ASME2SSME_Time_Unit_ConstantEnum(min_u);
				lparam.add(unit1);
			}
		}
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(FLOWLATENCY_PROPERTY_ID,lparam, lin);
	}
	
	/**
	 * Class constructor
	 */
	public ASME2SSME_Translate_Property() { 
		aadlColAPI = new AADLCoLAPI();
		myLib= new signalTreeAPI();	
	}

	
	
	/**
	 * Returns a constant enumeration value whose type is Time_Units
	 * 
	 * @param cst_value a String name of the enumeration value
	 * @return a constan enumeration implementation object
	 */
	public ConstantEnumImpl ASME2SSME_Time_Unit_ConstantEnum(String cst_value){
		ConstantEnumImpl cst_enum = myLib.STree_mkEnumConstant(TIME_UNITS_ID, cst_value.toLowerCase());
		return cst_enum;		
	}

	/** 
	 * Returns the String type name of a data classifier (dclass)
	 * <p>
	 * If dclass is a DataType, return the type name (ComponentType_GetName()), 
	 * if dclass is a DataImpl, return the Name_of_Data(), 
	 * if dclass is null, return "integer" by default
	 * 
	 * @param dclass a data classifier component
	 * @return a String name of this data type 
	 */
	public String Name_of_Reference_data_classifier(DataClassifier dclass) {
		if (dclass instanceof DataType) return Name_of_DataType(aadlColAPI.ComponentType_GetName((DataType) dclass));
		if (dclass instanceof DataImplementation) return Name_of_Data(aadlColAPI.ComponentImpl_GetName((DataImplementation) dclass));
		return Name_of_DataType(null);
	}

	/** 
	 * Returns a Signal process call that represents a property of a device (type or implementation)
	 * <p>
	 * if "Period" property, use ASME2SSME_Period_Property(), 
	 * if "Device_Dispatch_Protocol" property, use ASME2SSME_Device_Dispatch_Protocol_property(), 
	 * else use ASME2SSME_Property_Call() for other properties
	 * 
	 * @param pa a property association defined for a device component
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Property_Call(PropertyAssociation pa){
		String propertyDef_name = aadlColAPI.Property_Get_Name(pa);
		if (propertyDef_name.equals(DEVICE_DISPATCH_PROTOCOL_ID)) return ASME2SSME_Device_Dispatch_Protocol_Property(pa);
		if (propertyDef_name.equals(PERIOD_ID)) return ASME2SSME_Period_Property(pa);
		if (propertyDef_name.equals(ACTUAL_PROCESSOR_BINDING_ID)) return ASME2SSME_Actual_Processor_Binding_Property(pa);
		if (propertyDef_name.equals(ACTUAL_CONNECTION_BINDING_ID)) return ASME2SSME_Actual_Connection_Binding_Property(pa);
		if (propertyDef_name.equals(DISPATCH_PROTOCOL_ID)) return ASME2SSME_Dispatch_Protocol_Property(pa);
		if (propertyDef_name.equals(DEADLINE_ID)) return ASME2SSME_Deadline_Property(pa);
		if (propertyDef_name.equals(TIMING_ID)) return ASME2SSME_Timing_Property_Call(pa);
		if (propertyDef_name.equals(FAN_OUT_POLICY_ID)) return ASME2SSME_Fan_Out_Policy_Property_Call(pa);
		if (propertyDef_name.equals(QUEUE_SIZE_ID)) return ASME2SSME_Queue_Size_Property_Call(pa);
		if (propertyDef_name.equals(DEQUEUE_PROTOCOL_ID)) return ASME2SSME_Dequeue_Protocol_Property_Call(pa);
		if (propertyDef_name.equals(DEQUEUED_ITEMS_ID)) return ASME2SSME_Dequeued_Items_Property_Call(pa);
		if (propertyDef_name.equals(QUEUE_PROCESSING_PROTOCOL_ID)) return ASME2SSME_Queue_Processing_Protocol_Property_Call(pa);
		if (propertyDef_name.equals(OVERFLOW_HANDLING_PROTOCOL_ID)) return ASME2SSME_Overflow_Handling_Protocol_Property_Call(pa);
		if (propertyDef_name.equals(INPUT_TIME_REFERENCE_TIME_ID)) return ASME2SSME_Input_Time_Reference_Time_Property_Call(pa);
		if (propertyDef_name.equals(OUTPUT_TIME_REFERENCE_TIME_ID)) return ASME2SSME_Output_Time_Reference_Time_Property_Call(pa);
		if (propertyDef_name.equals(TIME_OFFSET_ID)) return ASME2SSME_Time_Offset_Property_Call(pa);
		if (propertyDef_name.equals(PRIORITY_ID)) return ASME2SSME_Priority_Property_Call(pa);
		if (propertyDef_name.equals(CLOCK_PERIOD_ID)) return ASME2SSME_Clock_Period_Property(pa);
		if (propertyDef_name.equals(READ_TIME_ID)) return ASME2SSME_Read_Time_Property(pa);
		return ASME2SSME_Property_Call_withName(pa); 
	}

	/** 
	 * Returns a Signal process call that represents a property of a device (type or implementation)
	 * <p>
	 * if "Period" property, use ASME2SSME_Period_Property(), 
	 * if "Device_Dispatch_Protocol" property, use ASME2SSME_Device_Dispatch_Protocol_property(), 
	 * else use ASME2SSME_Property_Call() for other properties
	 * 
	 * @param pa a property association defined for a device component
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Device_property_call(PropertyAssociation pa){
		return ASME2SSME_Property_Call(pa);
	}	


	/** 
	 * Returns a Signal process call that represents a Period property of a thread implementation
	 * <p>
	 * Gets the period unit (Thread_Get_Period_Unit()) and value (Thread_Get_Period_Value()) as parameters of this process call. 
	 * 
	 * @param pa a "Period" property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Period_Property(PropertyAssociation pa){

		ArrayList<ExprParam> lparam; 
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		lparam = mkPeriodUnitParameters(aadlColAPI.Thread_Get_Period_Unit(pa), aadlColAPI.Thread_Get_Period_Value(pa));
		return mkSignalProperty(PERIOD_PROPERTY,lparam, lin);

	}

	/** 
	 * Returns a Signal process call that represents a "Deadline" property of a thread implementation
	 * <p>
	 * Gets the  Deadline unit (Thread_Get_Deadline_Unit()) and value (Thread_Get_Deadline_Value()) as process call parameters
	 * 
	 * @param pa a Deadline property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Deadline_Property(PropertyAssociation pa){		
		ArrayList<ExprParam> lparam;
		lparam = mkPeriodUnitParameters(aadlColAPI.Thread_Get_Deadline_Unit(pa), aadlColAPI.Thread_Get_Deadline_Value(pa));
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(DEADLINE_PROPERTY_ID,lparam, lin);		
	}


	/** 
	 * Returns a Signal process call that represents a "Dispatch_Protocol" property of a thread implementation
	 * <p>
	 * Gets the Dispatch_Protocol value using Thread_Get_Dispatch_Protocol() method
	 * 
	 * @param pa a Dispatch_Protocol property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Dispatch_Protocol_Property(PropertyAssociation pa){
		String str_dispatch_protocol = aadlColAPI.Thread_Get_DispatchProtocol_str(pa);
		ConstantEnumImpl dispatch_protocol = myLib.STree_mkEnumConstant(SUPPORTED_DISPATCH_PROTOCOLS, str_dispatch_protocol);
		return mkSignalProperty( DISPATCH_PROTOCOL_PROPERTY, dispatch_protocol);

	}

	/** 
	 * Returns a Signal process call that represents a "Clock_Period" property
	 * 
	 * @param pa a Clock_Period property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Clock_Period_Property(PropertyAssociation pa){
		ArrayList<ExprParam> lparam;
		lparam = mkPeriodUnitParameters(aadlColAPI.Property_ClockPeriod_Unit_str(pa), aadlColAPI.Property_ClockPeriod_Value_str(pa));
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(CLOCK_PERIOD_PROPERTY_ID,lparam, lin);
	}

	/**  
	 * Returns a Signal process call that represents a "Read_Time" property. 
	 * The value of a Read_Time property is a record of (Fixed, PerBype), 
	 * where each field is a TimeRange
	 * 
	 * @param pa a Read_Time property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Read_Time_Property(PropertyAssociation pa){
		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();

		//the min unit of Fixed field TimeRange
		String unit1 = aadlColAPI.Property_Get_ReadTime_Fixed_MinUnit_str(pa);
		ConstantEnumImpl cunit1 = ASME2SSME_Time_Unit_ConstantEnum(unit1);
		lparam.add(cunit1);

		//the min value of Fixed field TimeRange
		String value1 = aadlColAPI.Property_Get_ReadTime_Fixed_MinValue_str(pa);
		ConstantRealImpl cvalue1 = myLib.STree_mkRealConstant(value1);
		lparam.add(cvalue1);

		//the max unit of Fixed field TimeRange
		String unit2 = aadlColAPI.Property_Get_ReadTime_Fixed_MaxUnit_str(pa);
		ConstantEnumImpl cunit2 = ASME2SSME_Time_Unit_ConstantEnum(unit2);
		lparam.add(cunit2);

		//the max value of Fixed field TimeRange
		String value2 = aadlColAPI.Property_Get_ReadTime_Fixed_MaxValue_str(pa);
		ConstantRealImpl cvalue2 = myLib.STree_mkRealConstant(value2);
		lparam.add(cvalue2);

		//the min unit of PerByte field TimeRange
		String unit3 = aadlColAPI.Property_Get_ReadTime_PerByte_MinUnit_str(pa);
		ConstantEnumImpl cunit3 = ASME2SSME_Time_Unit_ConstantEnum(unit3);
		lparam.add(cunit3);

		//the min value of PerByte field TimeRange
		String value3 = aadlColAPI.Property_Get_ReadTime_PerByte_MinValue_str(pa);
		ConstantRealImpl cvalue3 = myLib.STree_mkRealConstant(value3);
		lparam.add(cvalue3);

		//the max unit of PerByte field TimeRange
		String unit4 = aadlColAPI.Property_Get_ReadTime_PerByte_MaxUnit_str(pa);
		ConstantEnumImpl cunit4 = ASME2SSME_Time_Unit_ConstantEnum(unit4);
		lparam.add(cunit4);

		//the max value of PerByte field TimeRange
		String value4 = aadlColAPI.Property_Get_ReadTime_PerByte_MaxValue_str(pa);
		ConstantRealImpl cvalue4 = myLib.STree_mkRealConstant(value4);
		lparam.add(cvalue4);
		return mkSignalProperty(READ_TIME_PROPERTY_ID,lparam, lin);
	}

	/** 
	 * Returns a Signal process call that represents a "Actual_Processor_Binding" property of a system implementation
	 * <p>
	 * Gets the AppliesTo component (process component) and Reference element (processor component) as process call parameters
	 * 
	 * @param pa a Actual_Processor_Binding property of a system implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Actual_Processor_Binding_Property(PropertyAssociation pa){

		Trace("ASME2SSME_Translate_Property : ASME2SSME_Actual_Processor_Binding_Property()");

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();

		ArrayList<String> list_appliesto_str = aadlColAPI.Property_Get_AppliesTo(pa);
		for (int i=0; i< list_appliesto_str.size(); i++){
			String appliesto_str = list_appliesto_str.get(i);
			StringValueImpl  appliesto = myLib.STree_mkStringValue(appliesto_str);	    
			lparam.add(appliesto);
		}

		ArrayList<String> list_reference_element_str = aadlColAPI.Property_Get_ReferenceElements(pa);
		for (int j=0; j< list_reference_element_str.size(); j++){
			String reference_element_str = list_reference_element_str.get(j);
			StringValueImpl  reference_element = myLib.STree_mkStringValue(reference_element_str);
			lparam.add(reference_element);
		}
		return mkSignalProperty(ACTUAL_PROCESSOR_BINDING_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call that represents a "Actual_Connection_Binding" property of a system implementation
	 * <p>
	 * Gets the AppliesTo component (process component) and Reference element (processor component) as process call parameters
	 * 
	 * @param pa a Actual_Connection_Binding property of a system implementation
	 * @return a Signal process call
	 */	
	public ProcessCallImpl ASME2SSME_Actual_Connection_Binding_Property(PropertyAssociation pa){

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		ArrayList<String> list_appliesto_str = aadlColAPI.Property_Get_AppliesTo(pa);
		for (int i=0; i< list_appliesto_str.size(); i++){
			String appliesto_str = list_appliesto_str.get(i);
			IdentifierImpl appliesto = myLib.mkIdentifier(appliesto_str);
			lparam.add(appliesto);
		}
		ArrayList<String> list_reference_element_str = aadlColAPI.Property_Get_ReferenceElements(pa);
		for (int j=0; j< list_reference_element_str.size(); j++){
			String reference_element_str = list_reference_element_str.get(j);
			IdentifierImpl reference_element = myLib.mkIdentifier(reference_element_str);
			lparam.add(reference_element);
		}
		return mkSignalProperty(ACTUAL_CONNECTION_BINDING_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call that represents a "Overflow_Handling_Protocol" property of a thread implementation
	 * <p>
	 * Gets the  Overflow_Handling_Protocol (Property_Get_Overflow_Handling_Protocol()) as process call parameters
	 * 
	 * @param pa a Overflow_Handling_Protocol property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Overflow_Handling_Protocol_Property_Call(PropertyAssociation pa){

		String str = aadlColAPI.Property_Get_OverflowHandlingProtocol_str(pa);
		ConstantEnumImpl cst = myLib.STree_mkEnumConstant("Overflow_Handling_Protocol",str);
		return mkSignalProperty(OVERFLOW_HANDLING_PROTOCOL_PROPERTY_ID, cst);
	}


	/** 
	 * Returns a Signal process call that represents a "Input_Time_Reference_Time" property of a thread implementation
	 * <p>
	 * Gets the  Input_Time_Reference_Time (Property_Get_Input_Time_Reference_Time()) as process call parameters
	 * 
	 * @param pa a Input_Time_Reference_Time property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Input_Time_Reference_Time_Property_Call(PropertyAssociation pa){

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		// String str = aadlColAPI.Property_Get_Input_Time_Reference_Time(pa);
		// ConstantEnumImpl cst = myLib.STree_mkEnumConstant("Input_Time_Reference_Time",str);
		// lparam.add(cst);
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(INPUT_TIME_REFERENCE_TIME_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call that represents a "Output_Time_Reference_Time" property of a thread implementation
	 * <p>
	 * Gets the  Output_Time_Reference_Time (Property_Get_Output_Time_Reference_Time()) as process call parameters
	 * 
	 * @param pa a Input_Time_Reference_Time property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Output_Time_Reference_Time_Property_Call(PropertyAssociation pa){

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		//		String str = aadlColAPI.Property_Get_Output_Time_Reference_Time(pa);
		//		ConstantEnumImpl cst = myLib.STree_mkEnumConstant("Output_Time_Reference_Time",str);
		//		lparam.add(cst);
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(OUTPUT_TIME_REFERENCE_TIME_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call of a port's Input_Time property.
	 * <p>
	 * This process call is in the form of: 
	 * Input_Time_property{Time_Units#ns,TIme_Unitsns, 2, 4}(Frozen_time_event, Reference_time_event). 
	 * It Gets the Input_Time property information of a data port. 
	 * The values of min_offset_unit, max_offset_unit, min_offset, max_offset are fetched by 
	 * Port_Get_Time_Offset_MinUnit(), Port_Get_Time_Offset_MaxUnit(), Port_Get_Time_Offset_MinOffset() and Port_Get_Time_Offset_MaxOffset() methods. 
	 * They are passed as parameter of this process call. 
	 * 
	 * @param t a thread implementation component
	 * @param p an in data port of this thread
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Time_Offset_Property_Call(PropertyAssociation pa){

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		//		String strArray[] = aadlColAPI.Property_Get_Time_Offset(pa);
		//		String s_min_offset = strArray[0];
		//		ConstantRealImpl cr1 = myLib.STree_mkRealConstant(s_min_offset);			
		//		lparam.add(cr1);
		//		String s_min_unit = strArray[1];
		//		ConstantEnumImpl min_unit = ASME2SSME_Time_Unit_ConstantEnum(s_min_unit);
		//		lparam.add(min_unit);
		//		String s_max_offset = strArray[2];
		//		ConstantRealImpl cr2 = myLib.STree_mkRealConstant(s_max_offset);
		//		lparam.add(cr2);
		//		String s_max_unit = strArray[3];
		//		ConstantEnumImpl max_unit = ASME2SSME_Time_Unit_ConstantEnum(s_max_unit);
		//		lparam.add(max_unit);

		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(TIME_OFFSET_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call of a port's Input_Time property.
	 * <p>
	 * This process call is in the form of: 
	 * Input_Time_property{Time_Units#ns,TIme_Unitsns, 2, 4}(Frozen_time_event, Reference_time_event). 
	 * It Gets the Input_Time property information of a data port. 
	 * The values of min_offset_unit, max_offset_unit, min_offset, max_offset are fetched by 
	 * Port_Get_Time_Offset_MinUnit(), Port_Get_Time_Offset_MaxUnit(), Port_Get_Time_Offset_MinOffset() and Port_Get_Time_Offset_MaxOffset() methods. 
	 * They are passed as parameter of this process call. 
	 * 
	 * @param t a thread implementation component
	 * @param p an in data port of this thread
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_InputTime(ThreadImplementation t, Port p){

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();

		String s_min_unit = aadlColAPI.Port_Get_InputTime_Offset1_MinUnit_str(t, p);
		//IdentifierImpl min_unit = myLib.mkIdentifier(s_min_unit);
		ConstantEnumImpl min_unit = ASME2SSME_Time_Unit_ConstantEnum(s_min_unit);
		lparam.add(min_unit);

		String s_max_unit = aadlColAPI.Port_Get_InputTime_Offset1_MaxUnit_str(t, p);
		//IdentifierImpl max_unit = myLib.mkIdentifier(s_max_unit);
		ConstantEnumImpl max_unit = ASME2SSME_Time_Unit_ConstantEnum(s_max_unit);
		lparam.add(max_unit);

		String s_min_offset = aadlColAPI.Port_Get_InputTime_Offset1_MinValue_str(t, p);
		ConstantRealImpl cr1 = myLib.STree_mkRealConstant(s_min_offset);			
		lparam.add(cr1);

		String s_max_offset = aadlColAPI.Port_Get_InputTime_Offset1_MaxValue_str(t, p);
		ConstantRealImpl cr2 = myLib.STree_mkRealConstant(s_max_offset);
		lparam.add(cr2);

		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		lin.add(myLib.mkIdentifier(FROZEN_TIME_EVENT_ID));
		lin.add(myLib.mkIdentifier(REFERENCE_TIME_EVENT_ID));
		return mkSignalProperty(INPUT_TIME_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call of an output port's Output_Time property.
	 * <p>
	 * This process call is in the form of: 
	 * Output_Time_property{Time_Units#ns,TIme_Unitsns, 2, 4}(Output_time_event, Reference_time_event). 
	 * It Gets the Output_Time property information of an output data port. 
	 * The values of min_offset_unit, max_offset_unit, min_offset, max_offset are fetched by 
	 * Port_Get_Time_Offset_MinUnit(), Port_Get_Time_Offset_MaxUnit(), Port_Get_Time_Offset_MinOffset() and Port_Get_Time_Offset_MaxOffset() methods. 
	 * They are passed as parameter of this process call. 
	 * 
	 * @param t a thread implementation component
	 * @param p an out data port of this thread
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_OutputTime(ThreadImplementation t, Port p){

		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();

		String s_min_unit = aadlColAPI.Port_Get_OutputTime_Offset1_MinUnit_str(t, p);
		//IdentifierImpl min_unit = myLib.mkIdentifier(s_min_unit);
		ConstantEnumImpl min_unit = ASME2SSME_Time_Unit_ConstantEnum(s_min_unit);
		lparam.add(min_unit);

		String s_max_unit = aadlColAPI.Port_Get_OutputTime_Offset1_MaxUnit_str(t, p);
		//IdentifierImpl max_unit = myLib.mkIdentifier(s_max_unit);
		ConstantEnumImpl max_unit = ASME2SSME_Time_Unit_ConstantEnum(s_max_unit);
		lparam.add(max_unit);

		String s_min_offset = aadlColAPI.Port_Get_OutputTime_Offset1_MinValue_str(t, p);
		ConstantRealImpl r_min_offset = myLib.STree_mkRealConstant(s_min_offset);			
		//IdentifierImpl min_offset = myLib.mkIdentifier(s_min_offset);
		lparam.add(r_min_offset);

		String s_max_offset = aadlColAPI.Port_Get_OutputTime_Offset1_MaxValue_str(t, p);
		ConstantRealImpl r_max_offset = myLib.STree_mkRealConstant(s_max_offset);
		//IdentifierImpl max_offset = myLib.mkIdentifier(s_max_offset);
		lparam.add(r_max_offset);

		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		lin.add(myLib.mkIdentifier(OUTPUT_TIME_EVENT_ID));
		lin.add(myLib.mkIdentifier(REFERENCE_TIME_EVENT_ID));
		return mkSignalProperty(OUTPUT_TIME_PROPERTY_ID,lparam, lin);
	}


	/**
	 * Return a Signal process call of a port´s Timing property
	 * 
	 * @param t thread implementation 
	 * @param p port of thread t
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Timing(ThreadImplementation t, Port p){
		String s_timing = aadlColAPI.Port_Get_Timing_str(t, p);
		//IdentifierImpl min_unit = myLib.mkIdentifier(s_min_unit);
		ConstantEnumImpl timing = myLib.STree_mkEnumConstant("Timing", s_timing);
		return mkSignalProperty(TIMING_PROPERTY_ID, timing);		 
	}

	

	/**
	 * Return a Signal process call of a port´s Overflow_Handling_Protocol property
	 * 
	 * @param t thread implementation
	 * @param p port of thread t
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Overflow_Handling_Protocol(ThreadImplementation t, Port p){

		PropertyAssociation pa = getPortPropertyAssociation(p, "Overflow_Handling_Protocol");
		if (pa != null) return ASME2SSME_Overflow_Handling_Protocol_Property_Call(pa);

		String s_overflow = aadlColAPI.Port_Get_Overflow_Handling_Protocol_str(t, p);
		//IdentifierImpl min_unit = myLib.mkIdentifier(s_min_unit);
		ConstantEnumImpl overflow = myLib.STree_mkEnumConstant("Overflow_Handling_Protocol", s_overflow);
		return mkSignalProperty(OVERFLOW_HANDLING_PROTOCOL_PROPERTY_ID, overflow);
	}

	/**
	 * Return a Signal process call of a port´s Queue_Size property
	 * 
	 * @param t thread implementation
	 * @param p port of thread t
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Queue_Size(ThreadImplementation t, Port p){

		PropertyAssociation pa = getPortPropertyAssociation(p, "Queue_Size");
		if (pa != null) return ASME2SSME_Queue_Size_Property_Call(pa);
		String s_size = aadlColAPI.Port_Get_QueueSize_str(t, p);
		ConstantIntegerImpl size = myLib.STree_mkIntegerConstant(s_size);
		return mkSignalProperty(QUEUE_SIZE_PROPERTY_ID, size);
	}


	/**
	 * Return a Signal process call of a port´s Dequeued_Items property
	 * 
	 * @param t thread implementation
	 * @param p port of thread t
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Dequeued_Items(ThreadImplementation t, Port p){

		PropertyAssociation pa = getPortPropertyAssociation(p, "Dequeued_Items");
		if (pa != null) return ASME2SSME_Dequeued_Items_Property_Call(pa);		

		String s_number = aadlColAPI.Port_Get_Dequeue_Number(t, p);
		ConstantIntegerImpl dequeued_items = myLib.STree_mkIntegerConstant(s_number);
		return mkSignalProperty(DEQUEUED_ITEMS_PROPERTY_ID, dequeued_items);
	}


	/**
	 * Return a Signal process call of a port´s Dequeue_Protocol property
	 * 
	 * @param t thread implementation
	 * @param p port of thread t
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Dequeue_Protocol(ThreadImplementation t, Port p){

		PropertyAssociation pa = getPortPropertyAssociation(p, DEQUEUE_PROTOCOL_ID);
		if (pa != null) return ASME2SSME_Dequeue_Protocol_Property_Call(pa);
		String s_dp = aadlColAPI.Port_Get_DequeueProtocol_str(t, p);
		ConstantEnumImpl dp = myLib.STree_mkEnumConstant(DEQUEUE_PROTOCOL_ID, s_dp);
		return mkSignalProperty(DEQUEUE_PROTOCOL_PROPERTY_ID, dp);
	}


	/**
	 * Return a Signal process call of a port´s Queue_Procesing_Protocol property
	 * 
	 * @param t thread implementation
	 * @param p port of thread t
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Queue_Processing_Protocol(ThreadImplementation t, Port p){

		PropertyAssociation pa = getPortPropertyAssociation(p, QUEUE_PROCESSING_PROTOCOL_ID);
		if (pa != null) return ASME2SSME_Queue_Processing_Protocol_Property_Call(pa);

		String s_qpp = aadlColAPI.Port_Get_Queue_Processing_Protocol_str(t, p);
		ConstantEnumImpl qpp = myLib.STree_mkEnumConstant(QUEUE_PROCESSING_PROTOCOL_ID, s_qpp);	
		return mkSignalProperty(QUEUE_PROCESSING_PROTOCOL_PROPERTY_ID, qpp);
	}


	/** 
	 * Returns a Signal process call of connection's Latency property.
	 * <p>
	 * This process call is in the form of: 
	 * Latency_property{Time_Units#ns,TIme_Unitsns, 2, 4}(Latency_time_event, Reference_time_event). 
	 * It Gets the Latency property information of a connection from its upper level component. 
	 * The values of min_unit, max_unit, min_offset, max_offset are fetched by 
	 * Connection_Get_Latency_MinUnit(), Connection_Get_Latency_MaxUnit(), Connection_Get_Latency_MinOffset() and Connection_Get_Latency_MaxOffset() methods. 
	 * They are passed as parameter of this process call. 
	 * 
	 * @param compImpl an upper level component implementation (normally, it is a system implementation component)
	 * @param pconnection a connection
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Latency_Property_Call(ComponentImplementation compImpl, Connection pconnection){
		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();

		String s_min_unit = aadlColAPI.Connection_Get_Latency_MinUnit(compImpl, pconnection);
		//IdentifierImpl min_unit = myLib.mkIdentifier(s_min_unit);
		ConstantEnumImpl min_unit = ASME2SSME_Time_Unit_ConstantEnum(s_min_unit);
		lparam.add(min_unit);

		String s_max_unit = aadlColAPI.Connection_Get_Latency_MaxUnit(compImpl, pconnection);
		//IdentifierImpl max_unit = myLib.mkIdentifier(s_max_unit);
		ConstantEnumImpl max_unit = ASME2SSME_Time_Unit_ConstantEnum(s_max_unit);
		lparam.add(max_unit);

		String s_min_offset = aadlColAPI.Connection_Get_Latency_MinOffset(compImpl, pconnection);
		ConstantRealImpl cr1 = myLib.STree_mkRealConstant(s_min_offset);			
		lparam.add(cr1);

		String s_max_offset = aadlColAPI.Connection_Get_Latency_MaxOffset(compImpl, pconnection);
		ConstantRealImpl cr2 = myLib.STree_mkRealConstant(s_max_offset);
		lparam.add(cr2);

		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		lin.add(myLib.mkIdentifier(LATENCY_TIME_EVENT_ID));
		lin.add(myLib.mkIdentifier(REFERENCE_TIME_EVENT_ID));

		return mkSignalProperty(LATENCY_PROPERTY_ID,lparam, lin);
	}


	/** 
	 * Returns a Signal process call that represents a "Device_Dispatch" property of a device
	 * <p>
	 * Gets the Device_Dispatch value using Property_Get_Device_Dispatch_Protocol() method, 
	 * and passes it as a process call parameter
	 * 
	 * @param pa a Device_Dispatch property of a device implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Device_Dispatch_Protocol_Property(PropertyAssociation pa){

		String vstr = aadlColAPI.Property_Get_DeviceDispatchProtocol_str(pa);
		ConstantEnumImpl device_dispatch_protocol = myLib.STree_mkEnumConstant("Supported_Dispatch_Protocols", vstr);
		return mkSignalProperty("Device_Dispatch_Protocol_property", device_dispatch_protocol);		
	}	

	/** 
	 * Returns a Signal process call that represents a "Timing" property of a port
	 * <p>
	 * Gets the Timing value using Property_Get_Timing() method, 
	 * and passes it as a process call parameter
	 * 
	 * @param pa a Timing property of a port
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Timing_Property_Call(PropertyAssociation pa){
		String str_timing = aadlColAPI.Property_Get_Timing_str(pa);
		ConstantEnumImpl cst_timing = myLib.STree_mkEnumConstant("Timing",str_timing);
		return mkSignalProperty("Timing_property", cst_timing);	
	}


	/** 
	 * Returns a Signal process call that represents a "Fan_Out_Policy" property of a port
	 * <p>
	 * Gets the Fan_Out_Policy value using Property_Get_Fan_Out_Policy() method, 
	 * and passes it as a process call parameter
	 * 
	 * @param pa a Fan_Out_Policy property of a port
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Fan_Out_Policy_Property_Call(PropertyAssociation pa){
		String str_fanout = aadlColAPI.Property_Get_FanOutPolicy_str(pa);
		ConstantEnumImpl cst_fanout = myLib.STree_mkEnumConstant("Fan_Out_Policy", str_fanout);
		return mkSignalProperty("Fan_Out_Policy_property", cst_fanout);
	}


	/** 
	 * Returns a Signal process call that represents a "Queue_Size" property of a thread implementation
	 * <p>
	 * Gets the  Queue_Size (Property_Get_Queue_Size()) as process call parameters
	 * 
	 * @param pa a Queue_Size property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Queue_Size_Property_Call(PropertyAssociation pa){
		String qsize = aadlColAPI.Property_Get_QueueSize_str(pa);
		ConstantRealImpl cst_size = myLib.STree_mkRealConstant(qsize);
		return mkSignalProperty("Queue_Size_property",  cst_size);		

	}


	/** 
	 * Returns a Signal process call that represents a "Priority" property of a thread implementation
	 * <p>
	 * Gets the  Priority (Property_Get_Priority()) as process call parameters
	 * 
	 * @param pa a Priority property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Priority_Property_Call(PropertyAssociation pa){
		String qsize = aadlColAPI.Property_Get_Priority_str(pa);
		ConstantRealImpl cst_size = myLib.STree_mkRealConstant(qsize);
		return mkSignalProperty("Priority_property",  cst_size);
	}



	/** 
	 * Returns a Signal process call that represents a "Dequeue_Protocol" property of a thread implementation
	 * <p>
	 * Gets the  Dequeue_Protocol (Property_Get_Dequeue_Protocol()) as process call parameters
	 * 
	 * @param pa a Dequeue_Protocol property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Dequeue_Protocol_Property_Call(PropertyAssociation pa){

		String dequeue_protocol = aadlColAPI.Property_Get_DequeueProtocol_str(pa);
		ConstantEnumImpl cst_dequeue_protocol = myLib.STree_mkEnumConstant(DEQUEUE_PROTOCOL_ID,dequeue_protocol);	 
		return mkSignalProperty(DEQUEUE_PROTOCOL_PROPERTY_ID, cst_dequeue_protocol);
	}


	/** 
	 * Returns a Signal process call that represents a "Dequeued_Items" property of a thread implementation
	 * <p>
	 * Gets the  Dequeued_Items (Property_Get_Dequeued_Items()) as process call parameters
	 * 
	 * @param pa a Queue_Size property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Dequeued_Items_Property_Call(PropertyAssociation pa){
		String str_items = aadlColAPI.Property_Get_DequeuedItems_str(pa);
		ConstantRealImpl cst_items = myLib.STree_mkRealConstant(str_items);
		return mkSignalProperty(DEQUEUED_ITEMS_PROPERTY_ID, cst_items);		
	}


	/** 
	 * Returns a Signal process call that represents a "Queue_Processing_Protocol" property of a thread implementation
	 * <p>
	 * Gets the  Queue_Processing_Protocol (Property_Get_Queue_Processing_Protocol()) as process call parameters
	 * 
	 * @param pa a Queue_Processing_Protocol property of a thread implementation
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Queue_Processing_Protocol_Property_Call(PropertyAssociation pa){
		String str = aadlColAPI.Property_Get_QueueProcessingProtocol_str(pa);
		ConstantEnumImpl cst = myLib.STree_mkEnumConstant(QUEUE_PROCESSING_PROTOCOL_ID,str);		
		return mkSignalProperty(QUEUE_PROCESSING_PROTOCOL_PROPERTY_ID, cst);
	}


	/**
	 * Return a Signal process call of Source_Name property
	 * 
	 * @param pa property association
	 * @return
	 */
	public ProcessCallImpl ASME2SSME_Source_Name(PropertyAssociation pa){

		String value = aadlColAPI.Property_Get_SourceName_str(pa);
		if (value == null) return null;

		StringValueImpl sn = myLib.STree_mkStringValue(value);		
		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		lparam.add(sn);	
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty("Source_Name",lparam, lin);
	}
	
	/** 
	 * Returns a Signal process call of flow's Latency property.
	 * <p>
	 * This process call is in the form of: 
	 * Latency_property{flow_name,3,Time_Units#ns, 5, Time_Units#ns}()
	 * 
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_FlowLatency_Property_Call(String flow_name, PropertyAssociation pa){
		return genLatencyProperty(pa, flow_name, LATENCY_ID);
	}

	

	/** 
	 * Returns a Signal process call of flow's Actual Latency property.
	 * <p>
	 * This process call is in the form of: 
	 * Latency_property{flow_name,3,Time_Units#ns, 5, Time_Units#ns}()
	 * 
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_ActualLatency_Property_Call(String flow_name, PropertyAssociation pa){
		return genLatencyProperty(pa, flow_name, ACTUAL_LATENCY_ID);
	}

	/** 
	 * Returns a Signal process call that represents a property
	 * <p>
	 * This process call is named as xx_property, where xx is the name of this property.  
	 * 
	 * @param pa a property association
	 * @return a Signal process call
	 */
	public ProcessCallImpl ASME2SSME_Property_Call_withName(PropertyAssociation pa){ 
		String propertyDef_name = aadlColAPI.Property_Get_Name(pa);
		Trace("\n property not yet completly implemented: " + propertyDef_name);
		String propertyCall_name = propertyDef_name + "_property";
		ArrayList<ExprParam> lparam = new  ArrayList<ExprParam>();
		ArrayList<ExprSignal> lin = new ArrayList<ExprSignal>();
		return mkSignalProperty(propertyCall_name,lparam, lin);
	}


	/**
	 * Returns a Signal process xx_property that represents the properties of a component implementation.
	 * <p>
	 * This process is named as xxx_property, where xxx is the name of component's corresponding Signal process. 
	 * Gets all the properties specified in this component implementation and also its type component. 
	 * For each such property, ASME2SSME_Property_Call() method is used to make a process call.
	 * 
	 * @param c_impl a component implementation
	 * @param process_name a String name of the c_impl's Signal process
	 * @return a ProcessModelImpl (Signal process)
	 */
	public ProcessModelImpl ASME2SSME_Component_Properties_Call(ComponentImplementation c_impl, String process_name){


		String pname = process_name + "_property";
		ProcessModelImpl p_property = myLib.STree_mkSkeletonModel(myLib.mkIdentifier(pname) );
		ArrayList<PropertyAssociation> property_association_list1 = aadlColAPI.ComponentImpl_GetPropertyAssociations(c_impl);
		ComponentType subp_type = aadlColAPI.ComponentImpl_GetComponentType(c_impl);
		ArrayList<PropertyAssociation> property_association_list2 = aadlColAPI.Component_GetPropertyAssociations(subp_type);
		property_association_list1.addAll(property_association_list2);
		for(int i=0; i<property_association_list1.size(); i++)
		{
			PropertyAssociation pa = property_association_list1.get(i);
			ProcessCallImpl pcall1 = ASME2SSME_Property_Call(pa);
			myLib.STree_addExpressionOfProcessToaModel(p_property, pcall1);   
		}
		return p_property;
	}


	/**
	 * Translates AADL property set
	 */
	public void ASME2SSME_PropertySet(PropertySet ps){

		Trace("\n ========ASME2SSME_PropertySet not yet implemented: " + ps.getName());
	}


	/**
	 * Prints out the information of a property association.
	 * <p>
	 * Gives out the AppliesTo classifier, 
	 * and the property values.
	 * 
	 * @param propertyAssociation a property association
	 */
	public void read_PropertyAssociation(PropertyAssociation  propertyAssociation){

		// Property propertyDef = propertyAssociation.getProperty();
		// EList<ContainedNamedElement> xy = propertyAssociation.getAppliesTos();

		//	for (int i = 0; i < xy.size(); i++) { 
		//		PropertyHolder z = (PropertyHolder) xy.get(i);
		//		//Trace("------applies to: " + z.getName());
		//	}
		//	
		//	EList listPropertyValue = propertyAssociation.getPropertyValue();
		//	for (int i = 0; i < listPropertyValue.size(); i++) {  
		//		if (listPropertyValue.get(i) instanceof edu.cmu.sei.aadl.model.property.impl.EnumValueImpl) {
		//			edu.cmu.sei.aadl.model.property.impl.EnumValueImpl propertyValue = (edu.cmu.sei.aadl.model.property.impl.EnumValueImpl) listPropertyValue.get(i);
		//			//Trace("------Value: " + propertyValue.getEnumLiteral().getName());
		//			propertyValue = null;
		//		}			
		//		if (listPropertyValue.get(i) instanceof edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl) {
		//			edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl propertyValue = (edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl) listPropertyValue.get(i);
		//			//Trace("------Value: " + propertyValue.getValueAsString());
		//			//Trace("------Base: " + Integer.toString(propertyValue.getBase()));
		//			propertyValue = null;
		//		}
		//		if (listPropertyValue.get(i) instanceof edu.cmu.sei.aadl.model.property.impl.IntegerRangeValueImpl) {
		//			edu.cmu.sei.aadl.model.property.impl.IntegerRangeValueImpl propertyValue = (edu.cmu.sei.aadl.model.property.impl.IntegerRangeValueImpl) listPropertyValue.get(i);
		//			edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl xx = (edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl) propertyValue.getMinimum();
		//			//Trace("------Value Minimum number: " + xx.getNumberAsString());
		//			//Trace("------Value Minimum unit: " + xx.getUnitLiteralName());
		//			edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl yy = (edu.cmu.sei.aadl.model.property.impl.IntegerValueImpl) propertyValue.getMaximum();
		//			//Trace("------Value Maximum number: " + yy.getNumberAsString());
		//			//Trace("------Value Maximum unit: " + yy.getUnitLiteralName());
		//			propertyValue = null;
		//		}
		//	}
	}
}
