 
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import java.io.IOException;
//import java.net.URI;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IPath;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
 

public class NewAction implements IObjectActionDelegate
{
	private StructuredSelection currentSelection;
	List<IFile> list  = new ArrayList<IFile>();
	private Shell shell;
	private IFile inputFile;
	private IFile aadlFile;
	IPath location;

	/**
	 * Constructor for Action1.
	 */
	public NewAction()
	{
		super();
	}
	
	
	/**
	 * Prints the string str in the console
	 * 
	 * @param str  a string to be printed out
	 */
	public void Trace(String str){
	  //  java.lang.System.out.println(str);
	}
	
	

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart)
	{
		shell = targetPart.getSite().getShell();
	}

	
	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(/*ExecutionEvent event*/  IAction action)
	{
		Trace("\n ******** NewAction: run ********");
//		IWorkspace workspace = ResourcesPlugin.getWorkspace();
		ASME2SSME asme2ssme =  new ASME2SSME();
		try {
			Trace("transfo on : "+ aadlFile.getLocation().toOSString());
			asme2ssme.startTransformation(aadlFile);
		} catch (IOException e) {
			Trace("transfo on : Exception");
			e.printStackTrace();
		}
		
		MessageDialog.openInformation( shell, "ASME(v2)2SSME transformation", "ASME(v2) to SSME transformation complete!");
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection)
	{
		Trace("\n ******** NewAction: selectionChanged ********");
		
		if (selection instanceof StructuredSelection)
		{
			currentSelection = (StructuredSelection) selection;
			Iterator<?> it = currentSelection.iterator();
			// IWorkspace workspace = ResourcesPlugin.getWorkspace();
			while (it.hasNext())
			{
				inputFile = (IFile) it.next();
				if (inputFile.getLocation().toOSString().contains("aadl2")) aadlFile = inputFile;
			}
		}
	}
	
}
