
package fr.inria.tea.aadl2ssme.transformation.popup.actions;

import java.io.*;
import java.util.Collections;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;

 /**
  * Some utility for saving files.
  *
  */
public final class SSMEUtils {
	 ;

	 /**
		 * Utility classes don't need to (and shouldn't) be instantiated.
		 */ 
	 private SSMEUtils() { 	// prevents instantiation
	}

	/**
	 * Prints the string str in the console
	 * 
	 * @param str
	 *            a string to be printed out
	 */
	private static void Trace(String str) {
		java.lang.System.out.println(str);
	}

	/**
	 * Writes an out file (aFile)
	 * 
	 * @param aFile
	 * @param aContents
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public static void WriteFile(File aFile, String aContents)
			throws FileNotFoundException, IOException {

		Trace("\n ******** ASME2SSME: WriteFile");
		if (aFile == null) throw new IllegalArgumentException("File should not be null.");
		if (!aFile.exists()) throw new FileNotFoundException("File does not exist: " + aFile);
		if (!aFile.isFile()) throw new IllegalArgumentException("Should not be a directory: " + aFile);
		if (!aFile.canWrite()) throw new IllegalArgumentException("File cannot be written: " + aFile);
		// use buffering
		Writer output = new BufferedWriter(new FileWriter(aFile));
		try {
			// FileWriter always assumes default encoding is OK!
			output.write(aContents);
		} finally {
			output.close();
		}
	}
  
	public static void save(EObject root, String path) throws IOException {
		ResourceSet resSet = new ResourceSetImpl();
		Resource resource = resSet.createResource(URI.createURI("file:" + path));
		resource.getContents().add(root);
		resource.save(Collections.EMPTY_MAP);
	}
}
